! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Global Data Module File
! 
! Generated by KPP-2.2.3_rs3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : messy_mecca_kpp_Global.f90
! Time                 : Mon Oct  5 12:57:27 2020
! Working directory    : /home/sander/git-repository/caaba-mecca/caaba/mecca
! Equation file        : messy_mecca_kpp.kpp
! Output root filename : messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE messy_mecca_kpp_Global

  USE messy_cmn_photol_mem ! IP_MAX, ip_*, jname
  USE messy_mecca_kpp_Parameters, ONLY: dp, NSPEC, NVAR, NFIX, NREACT
  PUBLIC
  SAVE


! Declaration of global variables

! C - Concentration of all species
  REAL(kind=dp) :: C(NSPEC)
! VAR - Concentrations of variable species (global)
  REAL(kind=dp) :: VAR(NVAR)
! FIX - Concentrations of fixed species (global)
  REAL(kind=dp) :: FIX(NFIX)
! VAR, FIX are chunks of array C
      EQUIVALENCE( C(1),VAR(1) )
      EQUIVALENCE( C(48),FIX(1) )
! RCONST - Rate constants (global)
  REAL(kind=dp) :: RCONST(NREACT)
! TIME - Current integration time
  REAL(kind=dp) :: TIME
! SUN - Sunlight intensity between [0,1]
  REAL(kind=dp) :: SUN
! TEMP - Temperature
  REAL(kind=dp) :: TEMP
! TSTART - Integration start time
  REAL(kind=dp) :: TSTART
! TEND - Integration end time
  REAL(kind=dp) :: TEND
! DT - Integration step
  REAL(kind=dp) :: DT
! ATOL - Absolute tolerance
  REAL(kind=dp) :: ATOL(NVAR)
! RTOL - Relative tolerance
  REAL(kind=dp) :: RTOL(NVAR)
! STEPMIN - Lower bound for integration step
  REAL(kind=dp) :: STEPMIN
! STEPMAX - Upper bound for integration step
  REAL(kind=dp) :: STEPMAX
! CFACTOR - Conversion factor for concentration units
  REAL(kind=dp) :: CFACTOR

! INLINED global variable declarations

  ! MECCA info from xmecca:
  CHARACTER(LEN=*), PUBLIC, PARAMETER :: &
    timestamp            = 'xmecca was run on 2020-10-05 at 12:57:25 by sander on machine fluorine', &
    batchfile            = 'simple', &
    gas_spc_file         = '-rw------- 1 sander sander 91165 Oct  2 21:10 gas.spc', &
    aqueous_spc_file     = '-rw------- 1 sander sander 40254 Oct  2 21:10 aqueous.spc', &
    gas_eqn_file         = '-rw-r--r-- 1 sander sander 323627 Oct  2 21:10 gas.eqn', &
    aqueous_eqn_file     = '-rw------- 1 sander sander 197318 Oct  2 21:10 aqueous.eqn', &
    gas_spc_file_sum     = '33183    90', &
    aqueous_spc_file_sum = '61480    40', &
    gas_eqn_file_sum     = '28656   317', &
    aqueous_eqn_file_sum = '46476   193', &
    rplfile              = '', &
    wanted               = 'Tr && G && !C && !S && !Cl && !Br && !I && !Hg', &
    diagtracfile         = '', &
    rxnrates             = 'n', &
    tag                  = 'n'
  LOGICAL, PARAMETER :: REQ_MCFCT = .FALSE.

  ! from xmecca for aerosol:
  INTEGER, PARAMETER, PUBLIC :: APN = 1
  ! from aerosol.awk:
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_O2_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_O3_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HO3_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HO4_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_OH_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HO2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_H2O_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_H2O2_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NH3_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NO_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NO2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NO3_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HONO_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HNO3_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HNO4_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3OH_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOOH_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCHO_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3O2_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2OH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2OOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3ONO2_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOOOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2O2_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOHO2_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCO3_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CO2H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PAN_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CHO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MG2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HMF_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C2H5OH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CH2O2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HYETHO2H_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ETHGLY_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CO3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CHO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHO2CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHO2CHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2COHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_GLYOX_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOCHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOHCHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOCO3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOCOHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOHCOHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOHCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CO3H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2OOCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C2H5OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C2H5O2_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOOCH2CO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOOCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOOCCOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOOHOOCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCO2H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_COOHCO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_COOHCOHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOOCH2CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOOCH2CHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2CHOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C2H5NO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CN_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2CO_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CHOHOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCO3H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOOCH2CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ETHOHNO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PHAN_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCH3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MG3_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HM2F_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MGLYOX_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCHOHOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCH2O2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ACETOL_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCHOHO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IPROPOL_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HYPERACET_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IC3H7OOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IC3H7O2_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ALCOCH2OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C33CO_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CHCO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCH2CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCH2CO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCH2CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCOCH2OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOC2H4CO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOC2H4CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2COCH2OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2COCHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HYPROPO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C32OH13CO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C3DIALOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCOHCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_METACETHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C3PAN1_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C3PAN2_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCH2O2NO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NOA_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PR2O2HNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PROPOLNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCOHPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_GOLIG1_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_GOLIG2_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_GOLIG3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HGO1_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HGO2_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HGO3_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MACR_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2OHCO2CH3CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MVK_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCHO2CH2OH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCOCH2OH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2OHCHOHCOCH3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BIACETO2_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BIACETOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BIACETOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BUT2OLO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BUT2OLOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C312COCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C413COOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C44OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4CODIAL_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCHCO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCOCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COOHCHCHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOC3COO2_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO23C3CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2C3CHO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2H3CHO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2H3CO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2H3CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCCH3CHOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOCCH3CO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HMAC_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HO12CO3C4_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HVMK_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IBUTALOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IBUTDIAL_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IBUTOLBOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IPRHOCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IPRHOCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MACO2H_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MACO3H_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MACROH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MACROOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZFUCO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZFUOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO14O3CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO14O3CO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2C4DIAL_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_EPXC4DIAL_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_EPXDLCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_EPXDLCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCOC4DIAL_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MALANHYOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MALDALCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MALDALCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MALDIAL_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MALDIALOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MALNHYOHCO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MECOACEOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C312COPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4PAN5_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MVKNO3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NBZFUOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NC4DCO2H_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LBUT1ENOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LHMVKABOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LMEKOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5H8_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C1ODC2O2C4OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C1ODC2OOHC4OD_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C1ODC3O2C4OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C1OOHC2OOHC4OD_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4MDIAL_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C511OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C512OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C513CO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C513OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C514OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C59OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOC3COOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO13C4CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO23C4CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO23C4CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DB1OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DB2OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPAOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPBOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPBOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPDOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPDOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MBO_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MBOACO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MBOCOCO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ME3FURAN_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ACCOMECHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ACCOMECO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C24O3CCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4CO2DBCO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4CO2DCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5134CO2OH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C54CO_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5CO14OH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5CO14OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5DIALCO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5DIALOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5DICARB_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5DICAROOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MC3ODBCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MMALNHYOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLFUOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4MCONO3OH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C514NO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5PAN9_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOC3COPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DB1NO3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPBNO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ISOPDNO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NC4OHCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NC4OHCPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NISOPOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NMBOBCO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C4CO2DBPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NC4MDCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NTLFUOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LC578OOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LHC4ACCHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LHC4ACCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LHC4ACCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LIEPOX_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LISOPACOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LMBOABOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LZCO3HC23DBCOD_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LC5PAN1719_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LISOPACNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LMBOABNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LNMBOABOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MGLYOXDA_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MGLYOXDB_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MGLYFA_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MGLYFB_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C614CO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C614OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO235C5CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO235C6OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZBIPEROOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZEMUCCO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZEMUCCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZEMUCCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZEMUCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZEPOXMUC_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZOBIPEROH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5CO2DCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5COOHCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6125CO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C615CO2OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6CO4DB_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6H5O_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6H5OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CATEC1O_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CATEC1OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CATECHOL_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PBZQCO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PBZQOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PHENOL_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PHENOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C614NO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZBIPERNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BZEMUCNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5CO2DBPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C5CO2OHPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DNPHEN_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DNPHENOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NBZQOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NCATECHOL_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NCATECOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NDNPHENOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NNCATECOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NPHENOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C235C6CO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C716OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C721OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C722OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO235C6CHO_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6COOHCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6H5CH2OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6H5CO3H_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C7CO4DB_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CRESOL_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CRESOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MCATEC1O_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MCATEC1OOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MCATECHOL_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_OXYL1OOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PHCOOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLBIPEROOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLEMUCCO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLEMUCCO2H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLEMUCCO3H_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLEMUCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLOBIPEROH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TOL1O_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C7PAN3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C6CO2OHPAN_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DNCRES_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DNCRESOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MNCATECH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MNCATECOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MNNCATCOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NCRESOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NDNCRESOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_TLEMUCNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C721CHO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C721CO3H_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C810OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C812OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C813OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C85OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C86OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C89OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C8BC_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C8BCCO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C8BCOOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NORPINIC_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_STYRENOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C721PAN_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C810NO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C89NO3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C8BCNO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C811CO3H_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C85CO3H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C89CO2H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C89CO3H_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C96OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C97OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C98OOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NOPINDCO_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NOPINDOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NOPINONE_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NOPINOO_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NORPINAL_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NORPINENOL_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PINIC_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C811PAN_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C89PAN_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C96NO3_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C9PAN2_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BPINAOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C106OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C109CO_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C109OOH_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_MENTHEN6ONE_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_OH2MENTHEN6ONE_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PERPINONIC_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PINAL_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PINALOOH_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PINENOL_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PINONIC_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BPINANO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C106NO3_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C10PAN2_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_PINALNO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_RO6R1NO3_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ROO6R1NO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LAPINABNO3_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LAPINABOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LNAPINABOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_LNBPINABOOH_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Cl_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Cl2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCl_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCl_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Br_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Br2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HBr_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOBr_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BrCl_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_I2_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IO_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOI_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ICl_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IBr_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_SO2_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_H2SO4_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DMS_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_DMSO_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Hg_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgO_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgOHOH_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgOHCl_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgCl2_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgBr2_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgSO3_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ClHgBr_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BrHgOBr_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ClHgOBr_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOH3_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeCl3_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeF3_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_O2m_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_OHm_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HO2m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_O2mm_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_O3m_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Hp_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NH4p_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NO2m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NO3m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_NO4m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO3m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCOOm_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HCO3m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COOm_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3CO3m_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CO3m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2OOCO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2OOHCO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOCH2CO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOOCO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOCO2m_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HOOCCO2m_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_C2O4m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOOHOOCO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CHOHOHCO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2CO2mm_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2CO3m_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CO2COHOHO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3COCO2m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Clm_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Cl2m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ClOm_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ClOHm_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Brm_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Br2m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BrOm_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BrOHm_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_BrCl2m_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Br2Clm_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Im_a        = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IO2m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IO3m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_ICl2m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_IBr2m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_SO3m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_SO3mm_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_SO4m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_SO4mm_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_SO5m_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HSO3m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HSO4m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HSO5m_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH3SO3m_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_CH2OHSO3m_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Hgp_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Hgpp_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgOHp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgClp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgBrp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_HgSO32mm_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Fepp_a      = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOpp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOHp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOH2p_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeClp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Feppp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeHOpp_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeHO2pp_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOHpp_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOH4m_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOHHO2p_a  = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeClpp_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeCl2p_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeBrpp_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeBr2p_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeFpp_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeF2p_a     = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeSO3p_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeSO4p_a    = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeSO42m_a   = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_FeOH2Fepppp_a = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_D1O_a       = 0
  INTEGER, PUBLIC, DIMENSION(APN) :: ind_Nap_a       = 0

  ! variable declarations from gas.eqn:
  ! --------------------------------------------------------------------------
  ! inorganic and C1 chemistry:
  REAL :: k_HO2_HO2, k_NO3_NO2, k_NO2_HO2, k_HNO3_OH, k_CH3OOH_OH, &
          k_CH3CO2H_OH, k_ClO_ClO, k_BrO_NO2, k_I_NO2, k_DMS_OH, k_CH2OO_SO2
  REAL :: k_O3s ! used in some *.rpl files
  ! new methane chemistry:
  REAL :: beta_null_CH3NO3, beta_inf_CH3NO3, beta_CH3NO3, &
          k_NO2_CH3O2, k_CH2OO_NO2, beta_C2H5NO3, k_C6H5O2_NO2
  ! NO2+OH from Amedro et al., ref3491:
  REAL :: k_NO2_OH, alpha_HOONO, k_NO2_OH_lpl, k_NO2_OH_hpl, k_NO2_OH_logF
  ! --------------------------------------------------------------------------
  ! only for mim1, see mim1.rpl:
  REAL :: k_PrO2_HO2, k_PrO2_NO, k_PrO2_CH3O2
  REAL :: k0_NO_HO2, k1d_NO_HO2, k1w_NO_HO2, k2d_NO_HO2, k2w_NO_HO2, &
          alpha_NO_HO2, beta_NO_HO2, f_BrO_CH3O2
  ! end of mim1 block
  ! --------------------------------------------------------------------------
  ! organic chemistry (MIM, MAM, MOM...):
  REAL :: k_CH3CO3_NO2, k_PAN_M
  REAL(dp) :: KRO2NO, KAPHO2, KAPNO, KRO2NO3, KNO3AL, KDEC
  ! maximum number of C atoms the rate coefficients are calculated for:
  REAL :: k_hsb, k_hsd, k_16hs, k_16hsz14, k_16hsz41, k_15hsdhb, k_14hsal, &
          k_15hs24vynal, k_15hs42vynal, k_hydec
  REAL :: j_IC3H7NO3, j_ACETOL, j_HPALD, j_ketene
  REAL(dp) :: RO2      ! sum of peroxy radicals
  REAL(dp) :: k_CH3O2   ! CH3O2 self-reaction
  REAL(dp) :: k_RO2RCO3, k_RO2pRO2, k_RO2sRO2, k_RO2tRO2, &
              k_RO2pORO2, k_RO2sORO2, k_RO2tORO2, &
              k_RO2LISOPACO2, k_RO2ISOPBO2, k_RO2ISOPDO2
  REAL(dp) :: k_CH2CHOH_OH_HCOOH, k_CH2CHOH_OH_ALD, k_CH2CHOH_HCOOH, k_ALD_HCOOH
  REAL(dp) :: k1_RO2RCO3, k1_RO2pRO2, k1_RO2sRO2, k1_RO2tRO2, &
              k1_RO2pORO2, k1_RO2sORO2, k1_RO2tORO2, &
              k1_RO2LISOPACO2, k1_RO2ISOPBO2, k1_RO2ISOPDO2
  REAL(dp), PARAMETER :: k_C6H5O_NO2  = 2.08E-12 ! ref3172
  REAL(dp), PARAMETER :: k_C6H5O_O3   = 2.86E-13 ! ref3171
  ! SAR for OH reactions (ref3030 with introduction of temperature dependency)
  ! parameters for the SAR on H-abstraction OH:
  REAL(dp) :: k_p, k_s, k_t, k_ROHRO, k_CO2H, k_ROOHRO
  REAL(dp), PARAMETER :: &
    f_sOH = 3.44, f_tOH = 2.68, &
    f_sOOH = 8.,  f_tOOH = 8., &
    f_ONO2 = 0.04 , f_CH2ONO2 = 0.2, &
    f_cpan= 0.25, f_allyl = 3.6, f_alk= 1.23, &
    f_CHO = 0.55, f_CO2H = 1.67, f_CO = 0.73, &
    f_O = 8.15, f_pCH2OH = 1.29, f_tCH2OH = 0.53
  ! parameters for the SAR on OH-addtion to alkenes
  ! Note for ach2ooh calculated
  ! assuming RO2 distribution in ref3159
  ! B, E, D, F, AC are 0.41, 0.02, 0.22, 0.05, 0.30 respectively
  REAL(dp) :: k_adp, k_ads, k_adt
  REAL(dp), PARAMETER :: &
    k_adsecprim = 3.0E-11, k_adtertprim = 5.7E-11 &
   , a_PAN = 0.56      , a_CHO = 0.31   , a_COCH3 = 0.76 &
   , a_CH2ONO2 = 0.64  , a_CH2OH = 1.7  , a_CH2OOH = 1.7 &
   , a_COH = 2.2       , a_COOH = 2.2   , a_CO2H = 0.25
  ! Branching ratios for RO2 + HO2 reactions
  ! CH3CO3 + HO2 has unique branching ratios (see reaction)
  ! beta-hydroxy acyl peroxy radicals, e.g. HOCH2CO3
  ! (GroC, PhD Thesis, ref3195)
  REAL(dp), PARAMETER :: r_CO3_OH  = 0.69, r_CO3_O3  = 0.10, r_CO3_OOH = 0.21
  ! beta-keto peroxy radicals equal or bigger than CH3COCHO2CH3 (Dillon and Crowley, ref3192)
  REAL(dp), PARAMETER :: r_COCH2O2_OH  = 0.15, r_COCH2O2_OOH = 0.85
  REAL(dp), PARAMETER :: r_CHOHCH2O2_OH = 0.10 ! derived from Liu ref3193 for ISOPBO2 and ISOPDO2. Consistent with exp. data by C. GroC (MPIC)
  REAL(dp), PARAMETER :: r_CH2OCH2O2_OH  = 0.4 ! ref3175 for CH3OCH2O2
  REAL(dp), PARAMETER :: r_BIPERO2_OH = 0.40 ! ref3188 for toluene
  REAL(dp), PARAMETER :: f_HPAL = 0.5 ! HPALD-yield after 1,6-H-shift
  ! --------------------------------------------------------------------------
  ! Parameters included for acid-base equilibria calculation
  ! used to enable the double use of the aqueous.eqn for liquid
  ! and aerosol phase.
  REAL(dp), PARAMETER :: &
    f_equil_HO2     = 1.e5_dp, f_equil_HONO    = 1.e5_dp,  &
    f_equil_HNO3    = 1.e7_dp, f_equil_HNO4    = 1.e5_dp,  &
    f_equil_HCOOH   = 1.e5_dp, f_equil_SO2     = 1.e9_dp,  &
    f_equil_HSO3m   = 1.e9_dp, f_equil_HSO4m   = 1.e7_dp,  &
    f_equil_NH3     = 1.e7_dp, f_equil_H2O     = 1.e9_dp,  &
    f_equil_CO2     = 1.e5_dp, f_equil_CH3CO2H = 25.e9_dp, &
    f_equil_HCl     = 1.e2_dp, f_equil_HBr     = 1.e6_dp,  &
    f_equil_HOCl    = 1.e2_dp, f_equil_HOBr    = 1.e2_dp,  &
    f_equil_ICl     = 1.e2_dp, f_equil_IBr     = 1.e2_dp,  &
    f_equil_IClBr   = 1.e2_dp, f_equil_H2SO4   = 1.e7_dp

  ! from xmecca:
  LOGICAL, PARAMETER :: REQ_HET     = .FALSE.
  LOGICAL, PARAMETER :: REQ_PHOTRAT = .TRUE.
  LOGICAL, PARAMETER :: REQ_AEROSOL = .FALSE.

  ! from xmecca:
  INTEGER, PARAMETER, PUBLIC :: MAX_MCEXP = 1
!KPPPP_DIRECTIVE vector variable definition start
  REAL :: mcexp(MAX_MCEXP) ! dummy Monte-Carlo factor
!KPPPP_DIRECTIVE vector variable definition end

  ! start of code from messy_mecca_kpp.kpp
  ! iht_ = index of troposheric heterogeneous reactions
  INTEGER, PARAMETER, PUBLIC :: &
    iht_N2O5      =  1, iht_HNO3      =  2, iht_Hg      =  3, iht_RGM       = 4
  INTEGER, PARAMETER, PUBLIC :: IHT_MAX = 4
  ! ihs_ = index of stratospheric heterogeneous reactions
  ! (must be the same as in messy_msbm.f90!)
  INTEGER, PARAMETER :: &
    ihs_N2O5_H2O  =  1, ihs_HOCl_HCl  =  2, ihs_ClNO3_HCl =  3, &
    ihs_ClNO3_H2O =  4, ihs_N2O5_HCl  =  5, ihs_ClNO3_HBr =  6, &
    ihs_BrNO3_HCl =  7, ihs_HOCl_HBr  =  8, ihs_HOBr_HCl  =  9, &
    ihs_HOBr_HBr  = 10, ihs_BrNO3_H2O = 11, ihs_Hg        = 12, &
    ihs_RGM       = 13
  INTEGER, PARAMETER, PUBLIC :: IHS_MAX = 13
!KPPPP_DIRECTIVE vector variable definition start
  ! IMPORTANT NOTES ABOUT TEMP, PRESS, AND CAIR:
  ! - The KPP variable "temp" is already defined automatically by KPP in
  !   messy_mecca_kpp_global.f90. The KPP variables "press" and "cair" are
  !   defined here.
  ! - The 3 variables temp, press, and cair are only used inside KPP.
  !   They are different from the variables with the same names in the base
  !   model (as used in the SMIL files *_si.f90 and *_box.f90)
  ! - Data transfer between the SMIL and the KPP variables is done via the
  !   fill subroutines in messy_mecca_kpp.f90:
  !   - fill_temp transfers temperature
  !   - fill_press transfers pressure
  !   - fill_cair transfers cair (this is redundant because cair could be
  !     calculated from temp and press; nevertheless, redundant transfer to
  !     KPP is preferred to avoid potential numerical differences when
  !     recalculating cair inside KPP)
  REAL(dp) :: cair      ! c(air) (wet) [mcl/cm^3]
  REAL(dp) :: press     ! pressure [Pa]
  REAL(dp) :: temp_ion  ! ion temperature [K]
  REAL(dp) :: temp_elec ! electron temperature [K]
  REAL(dp) :: xaer(APN)
  REAL(dp) :: cvfac(APN)    ! unit conversion factor
  REAL(dp) :: lwc(APN)      ! liquid water content
  REAL(dp) :: k_exf(APN,NSPEC) = 0.
  REAL(dp) :: k_exb(APN,NSPEC) = 0.
  REAL(dp) :: k_exf_N2O5(APN)  = 0.
  REAL(dp) :: k_exf_ClNO3(APN) = 0.
  REAL(dp) :: k_exf_BrNO3(APN) = 0.
  REAL(dp) :: jx(IP_MAX) = 0.
  REAL(dp) :: khet_Tr(IHT_MAX) = 0.
  REAL(dp) :: khet_St(IHS_MAX) = 0.
!KPPPP_DIRECTIVE vector variable definition end
  INTEGER, PUBLIC  :: xnom7sulf = 1 ! = 1-xm7sulf
  ! end of code from messy_mecca_kpp.kpp

  ! KPP info from xmecca (via integr.kpp):
  CHARACTER(LEN=*), PUBLIC, PARAMETER :: &
    mecca_spc_file     = '-rw------- 1 sander sander 139273 Oct  5 12:57 mecca.spc', &
    mecca_eqn_file     = '-rw------- 1 sander sander 79403 Oct  5 12:57 mecca.eqn', &
    mecca_spc_file_sum = '42152   137', &
    mecca_eqn_file_sum = '10417    78', &
    kppoption          = 'k', &
    KPP_HOME           = '/home/sander/git-repository/caaba-mecca/caaba/mecca/kpp', &
    KPP_version        = '2.2.3_rs3', &
    integr             = 'rosenbrock_posdef'

! INLINED global variable declarations


END MODULE messy_mecca_kpp_Global

