! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.2.3_rs3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : messy_mecca_kpp_Jacobian.f90
! Time                 : Mon Oct  5 12:57:27 2020
! Working directory    : /home/sander/git-repository/caaba-mecca/caaba/mecca
! Equation file        : messy_mecca_kpp.kpp
! Output root filename : messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE messy_mecca_kpp_Jacobian

  USE messy_mecca_kpp_Parameters
  USE messy_mecca_kpp_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP - the Jacobian of Variables in sparse matrix representation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      JVS       - sparse Jacobian of variables
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP ( V, F, RCT, JVS )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)


! Local variables
! B - Temporary array
  REAL(kind=dp) :: B(231)

! B(1) = dA(1)/dV(23)
  B(1) = RCT(1)*F(1)
! B(3) = dA(2)/dV(36)
  B(3) = RCT(2)*F(1)
! B(5) = dA(3)/dV(13)
  B(5) = RCT(3)*F(1)
! B(7) = dA(4)/dV(43)
  B(7) = RCT(4)*V(47)
! B(8) = dA(4)/dV(47)
  B(8) = RCT(4)*V(43)
! B(9) = dA(5)/dV(16)
  B(9) = RCT(5)*V(43)
! B(10) = dA(5)/dV(43)
  B(10) = RCT(5)*V(16)
! B(11) = dA(6)/dV(45)
  B(11) = RCT(6)*V(47)
! B(12) = dA(6)/dV(47)
  B(12) = RCT(6)*V(45)
! B(13) = dA(7)/dV(43)
  B(13) = RCT(7)*V(45)
! B(14) = dA(7)/dV(45)
  B(14) = RCT(7)*V(43)
! B(15) = dA(8)/dV(45)
  B(15) = RCT(8)*2*V(45)
! B(16) = dA(9)/dV(23)
  B(16) = RCT(9)*V(41)
! B(17) = dA(9)/dV(41)
  B(17) = RCT(9)*V(23)
! B(18) = dA(10)/dV(8)
  B(18) = 1.8e-12*V(43)
! B(19) = dA(10)/dV(43)
  B(19) = 1.8e-12*V(8)
! B(20) = dA(11)/dV(41)
  B(20) = RCT(11)*2*V(41)
! B(21) = dA(12)/dV(9)
  B(21) = 1
! B(22) = dA(13)/dV(23)
  B(22) = RCT(13)*F(2)
! B(24) = dA(14)/dV(40)
  B(24) = RCT(14)*V(47)
! B(25) = dA(14)/dV(47)
  B(25) = RCT(14)*V(40)
! B(26) = dA(15)/dV(38)
  B(26) = RCT(15)*V(47)
! B(27) = dA(15)/dV(47)
  B(27) = RCT(15)*V(38)
! B(28) = dA(16)/dV(40)
  B(28) = RCT(16)*V(42)
! B(29) = dA(16)/dV(42)
  B(29) = RCT(16)*V(40)
! B(30) = dA(17)/dV(38)
  B(30) = RCT(17)*V(42)
! B(31) = dA(17)/dV(42)
  B(31) = RCT(17)*V(38)
! B(32) = dA(18)/dV(6)
  B(32) = RCT(18)
! B(33) = dA(19)/dV(40)
  B(33) = RCT(19)*V(43)
! B(34) = dA(19)/dV(43)
  B(34) = RCT(19)*V(40)
! B(35) = dA(20)/dV(40)
  B(35) = RCT(20)*V(45)
! B(36) = dA(20)/dV(45)
  B(36) = RCT(20)*V(40)
! B(37) = dA(21)/dV(38)
  B(37) = RCT(21)*V(43)
! B(38) = dA(21)/dV(43)
  B(38) = RCT(21)*V(38)
! B(39) = dA(22)/dV(38)
  B(39) = RCT(22)*V(43)
! B(40) = dA(22)/dV(43)
  B(40) = RCT(22)*V(38)
! B(41) = dA(23)/dV(38)
  B(41) = RCT(23)*V(45)
! B(42) = dA(23)/dV(45)
  B(42) = RCT(23)*V(38)
! B(43) = dA(24)/dV(42)
  B(43) = 3.5e-12*V(45)
! B(44) = dA(24)/dV(45)
  B(44) = 3.5e-12*V(42)
! B(45) = dA(25)/dV(22)
  B(45) = RCT(25)*V(43)
! B(46) = dA(25)/dV(43)
  B(46) = RCT(25)*V(22)
! B(47) = dA(26)/dV(20)
  B(47) = RCT(26)*V(43)
! B(48) = dA(26)/dV(43)
  B(48) = RCT(26)*V(20)
! B(49) = dA(27)/dV(17)
  B(49) = RCT(27)
! B(50) = dA(28)/dV(17)
  B(50) = RCT(28)*V(43)
! B(51) = dA(28)/dV(43)
  B(51) = RCT(28)*V(17)
! B(52) = dA(29)/dV(4)
  B(52) = RCT(29)*V(43)
! B(53) = dA(29)/dV(43)
  B(53) = RCT(29)*V(4)
! B(54) = dA(30)/dV(31)
  B(54) = RCT(30)*V(47)
! B(55) = dA(30)/dV(47)
  B(55) = RCT(30)*V(31)
! B(56) = dA(31)/dV(31)
  B(56) = RCT(31)*V(45)
! B(57) = dA(31)/dV(45)
  B(57) = RCT(31)*V(31)
! B(58) = dA(32)/dV(31)
  B(58) = RCT(32)*V(45)
! B(59) = dA(32)/dV(45)
  B(59) = RCT(32)*V(31)
! B(60) = dA(33)/dV(31)
  B(60) = RCT(33)*V(40)
! B(61) = dA(33)/dV(40)
  B(61) = RCT(33)*V(31)
! B(62) = dA(34)/dV(31)
  B(62) = RCT(34)*V(40)
! B(63) = dA(34)/dV(40)
  B(63) = RCT(34)*V(31)
! B(64) = dA(35)/dV(31)
  B(64) = RCT(35)*V(38)
! B(65) = dA(35)/dV(38)
  B(65) = RCT(35)*V(31)
! B(66) = dA(36)/dV(31)
  B(66) = RCT(36)*V(38)
! B(67) = dA(36)/dV(38)
  B(67) = RCT(36)*V(31)
! B(68) = dA(37)/dV(26)
  B(68) = 1.2e-14*V(47)
! B(69) = dA(37)/dV(47)
  B(69) = 1.2e-14*V(26)
! B(70) = dA(38)/dV(26)
  B(70) = 1300
! B(71) = dA(39)/dV(30)
  B(71) = RCT(39)*V(43)
! B(72) = dA(39)/dV(43)
  B(72) = RCT(39)*V(30)
! B(73) = dA(40)/dV(15)
  B(73) = RCT(40)*V(30)
! B(74) = dA(40)/dV(30)
  B(74) = RCT(40)*V(15)
! B(75) = dA(41)/dV(30)
  B(75) = RCT(41)*V(38)
! B(76) = dA(41)/dV(38)
  B(76) = RCT(41)*V(30)
! B(77) = dA(42)/dV(15)
  B(77) = 1.66e-12*V(43)
! B(78) = dA(42)/dV(43)
  B(78) = 1.66e-12*V(15)
! B(79) = dA(43)/dV(12)
  B(79) = RCT(43)*V(43)
! B(80) = dA(43)/dV(43)
  B(80) = RCT(43)*V(12)
! B(81) = dA(44)/dV(30)
  B(81) = RCT(44)*F(1)
! B(83) = dA(45)/dV(10)
  B(83) = RCT(45)
! B(84) = dA(46)/dV(10)
  B(84) = RCT(46)*V(43)
! B(85) = dA(46)/dV(43)
  B(85) = RCT(46)*V(10)
! B(86) = dA(47)/dV(5)
  B(86) = RCT(47)*V(43)
! B(87) = dA(47)/dV(43)
  B(87) = RCT(47)*V(5)
! B(88) = dA(48)/dV(21)
  B(88) = RCT(48)*V(43)
! B(89) = dA(48)/dV(43)
  B(89) = RCT(48)*V(21)
! B(90) = dA(49)/dV(39)
  B(90) = RCT(49)*V(45)
! B(91) = dA(49)/dV(45)
  B(91) = RCT(49)*V(39)
! B(92) = dA(50)/dV(39)
  B(92) = RCT(50)*V(45)
! B(93) = dA(50)/dV(45)
  B(93) = RCT(50)*V(39)
! B(94) = dA(51)/dV(39)
  B(94) = RCT(51)*V(40)
! B(95) = dA(51)/dV(40)
  B(95) = RCT(51)*V(39)
! B(96) = dA(52)/dV(39)
  B(96) = RCT(52)*V(40)
! B(97) = dA(52)/dV(40)
  B(97) = RCT(52)*V(39)
! B(98) = dA(53)/dV(39)
  B(98) = 1.2e-12*V(42)
! B(99) = dA(53)/dV(42)
  B(99) = 1.2e-12*V(39)
! B(100) = dA(54)/dV(39)
  B(100) = RCT(54)
! B(101) = dA(55)/dV(39)
  B(101) = RCT(55)
! B(102) = dA(56)/dV(18)
  B(102) = RCT(56)*V(43)
! B(103) = dA(56)/dV(43)
  B(103) = RCT(56)*V(18)
! B(104) = dA(57)/dV(43)
  B(104) = RCT(57)*V(46)
! B(105) = dA(57)/dV(46)
  B(105) = RCT(57)*V(43)
! B(106) = dA(58)/dV(42)
  B(106) = RCT(58)*V(46)
! B(107) = dA(58)/dV(46)
  B(107) = RCT(58)*V(42)
! B(108) = dA(59)/dV(32)
  B(108) = RCT(59)*V(43)
! B(109) = dA(59)/dV(43)
  B(109) = RCT(59)*V(32)
! B(110) = dA(60)/dV(34)
  B(110) = RCT(60)*V(43)
! B(111) = dA(60)/dV(43)
  B(111) = RCT(60)*V(34)
! B(112) = dA(61)/dV(38)
  B(112) = RCT(61)*V(39)
! B(113) = dA(61)/dV(39)
  B(113) = RCT(61)*V(38)
! B(114) = dA(62)/dV(24)
  B(114) = RCT(62)
! B(115) = dA(63)/dV(24)
  B(115) = 3e-14*V(43)
! B(116) = dA(63)/dV(43)
  B(116) = 3e-14*V(24)
! B(117) = dA(64)/dV(29)
  B(117) = RCT(64)*V(43)
! B(118) = dA(64)/dV(43)
  B(118) = RCT(64)*V(29)
! B(119) = dA(65)/dV(37)
  B(119) = RCT(65)
! B(120) = dA(66)/dV(37)
  B(120) = RCT(66)*V(38)
! B(121) = dA(66)/dV(38)
  B(121) = RCT(66)*V(37)
! B(122) = dA(67)/dV(37)
  B(122) = RCT(67)*V(38)
! B(123) = dA(67)/dV(38)
  B(123) = RCT(67)*V(37)
! B(124) = dA(68)/dV(37)
  B(124) = RCT(68)*V(40)
! B(125) = dA(68)/dV(40)
  B(125) = RCT(68)*V(37)
! B(126) = dA(69)/dV(37)
  B(126) = RCT(69)*V(40)
! B(127) = dA(69)/dV(40)
  B(127) = RCT(69)*V(37)
! B(128) = dA(70)/dV(39)
  B(128) = RCT(70)*V(47)
! B(129) = dA(70)/dV(47)
  B(129) = RCT(70)*V(39)
! B(130) = dA(71)/dV(19)
  B(130) = RCT(71)*V(43)
! B(131) = dA(71)/dV(43)
  B(131) = RCT(71)*V(19)
! B(132) = dA(72)/dV(45)
  B(132) = RCT(72)*V(46)
! B(133) = dA(72)/dV(46)
  B(133) = RCT(72)*V(45)
! B(134) = dA(73)/dV(35)
  B(134) = RCT(73)
! B(135) = dA(74)/dV(35)
  B(135) = RCT(74)*V(45)
! B(136) = dA(74)/dV(45)
  B(136) = RCT(74)*V(35)
! B(137) = dA(75)/dV(35)
  B(137) = RCT(75)*V(40)
! B(138) = dA(75)/dV(40)
  B(138) = RCT(75)*V(35)
! B(139) = dA(76)/dV(35)
  B(139) = 1.2e-12*V(42)
! B(140) = dA(76)/dV(42)
  B(140) = 1.2e-12*V(35)
! B(141) = dA(77)/dV(35)
  B(141) = RCT(77)
! B(142) = dA(78)/dV(35)
  B(142) = RCT(78)
! B(143) = dA(79)/dV(28)
  B(143) = RCT(79)*V(43)
! B(144) = dA(79)/dV(43)
  B(144) = RCT(79)*V(28)
! B(145) = dA(80)/dV(28)
  B(145) = RCT(80)*V(43)
! B(146) = dA(80)/dV(43)
  B(146) = RCT(80)*V(28)
! B(147) = dA(81)/dV(11)
  B(147) = RCT(81)*V(43)
! B(148) = dA(81)/dV(43)
  B(148) = RCT(81)*V(11)
! B(149) = dA(82)/dV(39)
  B(149) = 1.4e-10*V(43)
! B(150) = dA(82)/dV(43)
  B(150) = 1.4e-10*V(39)
! B(151) = dA(83)/dV(44)
  B(151) = RCT(83)
! B(152) = dA(84)/dV(41)
  B(152) = RCT(84)*V(44)
! B(153) = dA(84)/dV(44)
  B(153) = RCT(84)*V(41)
! B(154) = dA(85)/dV(9)
  B(154) = 5.2e-12*V(44)
! B(155) = dA(85)/dV(44)
  B(155) = 5.2e-12*V(9)
! B(156) = dA(86)/dV(40)
  B(156) = 6e-14*V(44)
! B(157) = dA(86)/dV(44)
  B(157) = 6e-14*V(40)
! B(158) = dA(87)/dV(38)
  B(158) = RCT(87)*V(44)
! B(159) = dA(87)/dV(44)
  B(159) = RCT(87)*V(38)
! B(160) = dA(88)/dV(32)
  B(160) = 3.6e-14*V(44)
! B(161) = dA(88)/dV(44)
  B(161) = 3.6e-14*V(32)
! B(162) = dA(89)/dV(34)
  B(162) = 1e-10*V(44)
! B(163) = dA(89)/dV(44)
  B(163) = 1e-10*V(34)
! B(164) = dA(90)/dV(44)
  B(164) = 1.7e-12*V(46)
! B(165) = dA(90)/dV(46)
  B(165) = 1.7e-12*V(44)
! B(166) = dA(91)/dV(21)
  B(166) = 5e-12*V(44)
! B(167) = dA(91)/dV(44)
  B(167) = 5e-12*V(21)
! B(168) = dA(92)/dV(39)
  B(168) = 5e-12*V(44)
! B(169) = dA(92)/dV(44)
  B(169) = 5e-12*V(39)
! B(170) = dA(93)/dV(44)
  B(170) = 5e-12*V(45)
! B(171) = dA(93)/dV(45)
  B(171) = 5e-12*V(44)
! B(172) = dA(94)/dV(44)
  B(172) = 1e-12*V(47)
! B(173) = dA(94)/dV(47)
  B(173) = 1e-12*V(44)
! B(174) = dA(95)/dV(44)
  B(174) = 6e-11*2*V(44)
! B(175) = dA(96)/dV(35)
  B(175) = RCT(96)*V(38)
! B(176) = dA(96)/dV(38)
  B(176) = RCT(96)*V(35)
! B(177) = dA(97)/dV(25)
  B(177) = RCT(97)
! B(178) = dA(98)/dV(25)
  B(178) = RCT(98)*V(43)
! B(179) = dA(98)/dV(43)
  B(179) = RCT(98)*V(25)
! B(180) = dA(99)/dV(33)
  B(180) = RCT(99)*F(1)
! B(182) = dA(100)/dV(33)
  B(182) = RCT(100)*V(47)
! B(183) = dA(100)/dV(47)
  B(183) = RCT(100)*V(33)
! B(184) = dA(101)/dV(33)
  B(184) = 1.3e-10*V(36)
! B(185) = dA(101)/dV(36)
  B(185) = 1.3e-10*V(33)
! B(186) = dA(102)/dV(37)
  B(186) = 2.53e-14*V(47)
! B(187) = dA(102)/dV(47)
  B(187) = 2.53e-14*V(37)
! B(188) = dA(103)/dV(36)
  B(188) = 2.5e-11*V(37)
! B(189) = dA(103)/dV(37)
  B(189) = 2.5e-11*V(36)
! B(190) = dA(104)/dV(36)
  B(190) = 4.3e-11*V(39)
! B(191) = dA(104)/dV(39)
  B(191) = 4.3e-11*V(36)
! B(192) = dA(105)/dV(36)
  B(192) = RCT(105)*V(46)
! B(193) = dA(105)/dV(46)
  B(193) = RCT(105)*V(36)
! B(194) = dA(106)/dV(1)
  B(194) = RCT(106)
! B(195) = dA(107)/dV(27)
  B(195) = RCT(107)*V(43)
! B(196) = dA(107)/dV(43)
  B(196) = RCT(107)*V(27)
! B(197) = dA(108)/dV(23)
  B(197) = RCT(108)*V(27)
! B(198) = dA(108)/dV(27)
  B(198) = RCT(108)*V(23)
! B(199) = dA(109)/dV(23)
  B(199) = RCT(109)*V(27)
! B(200) = dA(109)/dV(27)
  B(200) = RCT(109)*V(23)
! B(201) = dA(110)/dV(23)
  B(201) = RCT(110)*V(27)
! B(202) = dA(110)/dV(27)
  B(202) = RCT(110)*V(23)
! B(203) = dA(111)/dV(27)
  B(203) = RCT(111)*V(36)
! B(204) = dA(111)/dV(36)
  B(204) = RCT(111)*V(27)
! B(205) = dA(112)/dV(14)
  B(205) = RCT(112)*F(1)
! B(207) = dA(113)/dV(14)
  B(207) = RCT(113)*F(1)
! B(209) = dA(114)/dV(7)
  B(209) = 7e-15*F(1)
! B(212) = dA(116)/dV(47)
  B(212) = RCT(116)
! B(213) = dA(117)/dV(47)
  B(213) = RCT(117)
! B(214) = dA(118)/dV(8)
  B(214) = RCT(118)
! B(215) = dA(119)/dV(38)
  B(215) = RCT(119)
! B(216) = dA(120)/dV(42)
  B(216) = RCT(120)
! B(217) = dA(121)/dV(42)
  B(217) = RCT(121)
! B(218) = dA(122)/dV(6)
  B(218) = RCT(122)
! B(219) = dA(123)/dV(22)
  B(219) = RCT(123)
! B(220) = dA(124)/dV(20)
  B(220) = RCT(124)
! B(221) = dA(125)/dV(17)
  B(221) = RCT(125)
! B(222) = dA(126)/dV(18)
  B(222) = RCT(126)
! B(223) = dA(127)/dV(46)
  B(223) = RCT(127)
! B(224) = dA(128)/dV(46)
  B(224) = RCT(128)
! B(225) = dA(129)/dV(19)
  B(225) = RCT(129)
! B(226) = dA(130)/dV(29)
  B(226) = RCT(130)
! B(227) = dA(131)/dV(24)
  B(227) = RCT(131)
! B(228) = dA(132)/dV(28)
  B(228) = RCT(132)
! B(229) = dA(133)/dV(39)
  B(229) = RCT(133)
! B(230) = dA(134)/dV(34)
  B(230) = RCT(134)
! B(231) = dA(135)/dV(25)
  B(231) = RCT(135)

! Construct the Jacobian terms from B's
! JVS(1) = Jac_FULL(1,1)
  JVS(1) = -B(194)
! JVS(2) = Jac_FULL(2,2)
  JVS(2) = 0
! JVS(3) = Jac_FULL(2,31)
  JVS(3) = B(64)
! JVS(4) = Jac_FULL(2,38)
  JVS(4) = B(65)
! JVS(5) = Jac_FULL(3,3)
  JVS(5) = 0
! JVS(6) = Jac_FULL(3,21)
  JVS(6) = 2*B(166)
! JVS(7) = Jac_FULL(3,39)
  JVS(7) = 2*B(168)
! JVS(8) = Jac_FULL(3,44)
  JVS(8) = 2*B(164)+2*B(167)+2*B(169)+B(170)
! JVS(9) = Jac_FULL(3,45)
  JVS(9) = B(171)
! JVS(10) = Jac_FULL(3,46)
  JVS(10) = 2*B(165)
! JVS(11) = Jac_FULL(4,4)
  JVS(11) = -B(52)
! JVS(12) = Jac_FULL(4,43)
  JVS(12) = -B(53)
! JVS(13) = Jac_FULL(5,5)
  JVS(13) = -B(86)
! JVS(14) = Jac_FULL(5,43)
  JVS(14) = -B(87)
! JVS(15) = Jac_FULL(6,6)
  JVS(15) = -B(32)-B(218)
! JVS(16) = Jac_FULL(6,38)
  JVS(16) = B(30)
! JVS(17) = Jac_FULL(6,42)
  JVS(17) = B(31)
! JVS(18) = Jac_FULL(7,7)
  JVS(18) = -B(209)
! JVS(19) = Jac_FULL(7,14)
  JVS(19) = B(205)
! JVS(20) = Jac_FULL(7,23)
  JVS(20) = B(199)
! JVS(21) = Jac_FULL(7,27)
  JVS(21) = B(200)+B(203)
! JVS(22) = Jac_FULL(7,36)
  JVS(22) = B(204)
! JVS(23) = Jac_FULL(8,8)
  JVS(23) = -B(18)-B(214)
! JVS(24) = Jac_FULL(8,43)
  JVS(24) = -B(19)
! JVS(25) = Jac_FULL(8,45)
  JVS(25) = B(15)
! JVS(26) = Jac_FULL(9,9)
  JVS(26) = -B(21)-B(154)
! JVS(27) = Jac_FULL(9,41)
  JVS(27) = B(20)
! JVS(28) = Jac_FULL(9,44)
  JVS(28) = -B(155)
! JVS(29) = Jac_FULL(10,10)
  JVS(29) = -B(83)-B(84)
! JVS(30) = Jac_FULL(10,38)
  JVS(30) = B(39)
! JVS(31) = Jac_FULL(10,43)
  JVS(31) = B(40)-B(85)
! JVS(32) = Jac_FULL(11,11)
  JVS(32) = -B(147)
! JVS(33) = Jac_FULL(11,35)
  JVS(33) = 0.5*B(142)
! JVS(34) = Jac_FULL(11,43)
  JVS(34) = -B(148)
! JVS(35) = Jac_FULL(12,12)
  JVS(35) = -B(79)
! JVS(36) = Jac_FULL(12,15)
  JVS(36) = B(73)
! JVS(37) = Jac_FULL(12,30)
  JVS(37) = B(74)
! JVS(38) = Jac_FULL(12,43)
  JVS(38) = -B(80)
! JVS(39) = Jac_FULL(13,13)
  JVS(39) = -B(5)
! JVS(40) = Jac_FULL(13,16)
  JVS(40) = B(9)
! JVS(41) = Jac_FULL(13,23)
  JVS(41) = B(199)
! JVS(42) = Jac_FULL(13,27)
  JVS(42) = B(200)+B(203)
! JVS(43) = Jac_FULL(13,32)
  JVS(43) = B(108)
! JVS(44) = Jac_FULL(13,33)
  JVS(44) = 0.956*B(182)+B(184)
! JVS(45) = Jac_FULL(13,36)
  JVS(45) = B(185)+0.3*B(192)+B(204)
! JVS(46) = Jac_FULL(13,43)
  JVS(46) = B(10)+B(109)
! JVS(47) = Jac_FULL(13,46)
  JVS(47) = 0.3*B(193)+B(224)
! JVS(48) = Jac_FULL(13,47)
  JVS(48) = 0.956*B(183)
! JVS(49) = Jac_FULL(14,14)
  JVS(49) = -B(205)-B(207)
! JVS(50) = Jac_FULL(14,23)
  JVS(50) = B(201)
! JVS(51) = Jac_FULL(14,27)
  JVS(51) = B(195)+B(202)
! JVS(52) = Jac_FULL(14,43)
  JVS(52) = B(196)
! JVS(53) = Jac_FULL(15,12)
  JVS(53) = B(79)
! JVS(54) = Jac_FULL(15,15)
  JVS(54) = -B(73)-B(77)
! JVS(55) = Jac_FULL(15,26)
  JVS(55) = B(70)
! JVS(56) = Jac_FULL(15,30)
  JVS(56) = -B(74)
! JVS(57) = Jac_FULL(15,43)
  JVS(57) = -B(78)+B(80)
! JVS(58) = Jac_FULL(16,16)
  JVS(58) = -B(9)
! JVS(59) = Jac_FULL(16,33)
  JVS(59) = 0.17*B(184)
! JVS(60) = Jac_FULL(16,36)
  JVS(60) = 0.17*B(185)
! JVS(61) = Jac_FULL(16,43)
  JVS(61) = -B(10)
! JVS(62) = Jac_FULL(16,46)
  JVS(62) = B(223)
! JVS(63) = Jac_FULL(17,17)
  JVS(63) = -B(49)-B(50)-B(221)
! JVS(64) = Jac_FULL(17,38)
  JVS(64) = B(41)
! JVS(65) = Jac_FULL(17,43)
  JVS(65) = -B(51)
! JVS(66) = Jac_FULL(17,45)
  JVS(66) = B(42)
! JVS(67) = Jac_FULL(18,18)
  JVS(67) = -B(102)-B(222)
! JVS(68) = Jac_FULL(18,39)
  JVS(68) = B(90)
! JVS(69) = Jac_FULL(18,43)
  JVS(69) = -B(103)
! JVS(70) = Jac_FULL(18,45)
  JVS(70) = B(91)
! JVS(71) = Jac_FULL(19,19)
  JVS(71) = -B(130)-B(225)
! JVS(72) = Jac_FULL(19,37)
  JVS(72) = B(124)
! JVS(73) = Jac_FULL(19,40)
  JVS(73) = B(125)
! JVS(74) = Jac_FULL(19,43)
  JVS(74) = -B(131)
! JVS(75) = Jac_FULL(20,20)
  JVS(75) = -B(47)-B(220)
! JVS(76) = Jac_FULL(20,38)
  JVS(76) = B(37)
! JVS(77) = Jac_FULL(20,42)
  JVS(77) = B(106)
! JVS(78) = Jac_FULL(20,43)
  JVS(78) = B(38)-B(48)
! JVS(79) = Jac_FULL(20,46)
  JVS(79) = B(107)
! JVS(80) = Jac_FULL(21,21)
  JVS(80) = -B(88)-B(166)
! JVS(81) = Jac_FULL(21,39)
  JVS(81) = 0.5*B(101)
! JVS(82) = Jac_FULL(21,43)
  JVS(82) = -B(89)
! JVS(83) = Jac_FULL(21,44)
  JVS(83) = -B(167)
! JVS(84) = Jac_FULL(22,22)
  JVS(84) = -B(45)-B(219)
! JVS(85) = Jac_FULL(22,30)
  JVS(85) = B(75)
! JVS(86) = Jac_FULL(22,37)
  JVS(86) = B(122)
! JVS(87) = Jac_FULL(22,38)
  JVS(87) = B(76)+B(123)
! JVS(88) = Jac_FULL(22,40)
  JVS(88) = B(33)
! JVS(89) = Jac_FULL(22,43)
  JVS(89) = B(34)-B(46)
! JVS(90) = Jac_FULL(23,23)
  JVS(90) = -B(1)-B(16)-B(22)-B(197)-B(199)-B(201)
! JVS(91) = Jac_FULL(23,27)
  JVS(91) = -B(198)-B(200)-B(202)
! JVS(92) = Jac_FULL(23,41)
  JVS(92) = -B(17)
! JVS(93) = Jac_FULL(23,47)
  JVS(93) = B(212)
! JVS(94) = Jac_FULL(24,24)
  JVS(94) = -B(114)-B(115)-B(227)
! JVS(95) = Jac_FULL(24,38)
  JVS(95) = B(112)
! JVS(96) = Jac_FULL(24,39)
  JVS(96) = B(113)
! JVS(97) = Jac_FULL(24,43)
  JVS(97) = -B(116)
! JVS(98) = Jac_FULL(25,25)
  JVS(98) = -B(177)-B(178)-B(231)
! JVS(99) = Jac_FULL(25,35)
  JVS(99) = B(175)
! JVS(100) = Jac_FULL(25,38)
  JVS(100) = B(176)
! JVS(101) = Jac_FULL(25,43)
  JVS(101) = -B(179)
! JVS(102) = Jac_FULL(26,26)
  JVS(102) = -B(68)-B(70)
! JVS(103) = Jac_FULL(26,31)
  JVS(103) = B(54)+B(56)+B(66)
! JVS(104) = Jac_FULL(26,38)
  JVS(104) = B(67)
! JVS(105) = Jac_FULL(26,45)
  JVS(105) = B(57)
! JVS(106) = Jac_FULL(26,47)
  JVS(106) = B(55)-B(69)
! JVS(107) = Jac_FULL(27,23)
  JVS(107) = -B(199)-B(201)
! JVS(108) = Jac_FULL(27,27)
  JVS(108) = -B(195)-B(200)-B(202)-B(203)
! JVS(109) = Jac_FULL(27,36)
  JVS(109) = -B(204)
! JVS(110) = Jac_FULL(27,41)
  JVS(110) = 0
! JVS(111) = Jac_FULL(27,43)
  JVS(111) = -B(196)
! JVS(112) = Jac_FULL(27,47)
  JVS(112) = 0
! JVS(113) = Jac_FULL(28,9)
  JVS(113) = B(154)
! JVS(114) = Jac_FULL(28,28)
  JVS(114) = -B(143)-B(145)-B(228)
! JVS(115) = Jac_FULL(28,35)
  JVS(115) = 0.5*B(135)
! JVS(116) = Jac_FULL(28,41)
  JVS(116) = B(152)
! JVS(117) = Jac_FULL(28,43)
  JVS(117) = -B(144)-B(146)
! JVS(118) = Jac_FULL(28,44)
  JVS(118) = B(153)+B(155)
! JVS(119) = Jac_FULL(28,45)
  JVS(119) = 0.5*B(136)
! JVS(120) = Jac_FULL(29,29)
  JVS(120) = -B(117)-B(226)
! JVS(121) = Jac_FULL(29,37)
  JVS(121) = B(120)
! JVS(122) = Jac_FULL(29,38)
  JVS(122) = B(121)
! JVS(123) = Jac_FULL(29,39)
  JVS(123) = B(96)
! JVS(124) = Jac_FULL(29,40)
  JVS(124) = B(97)
! JVS(125) = Jac_FULL(29,43)
  JVS(125) = -B(118)
! JVS(126) = Jac_FULL(30,15)
  JVS(126) = -B(73)+B(77)
! JVS(127) = Jac_FULL(30,26)
  JVS(127) = 0
! JVS(128) = Jac_FULL(30,30)
  JVS(128) = -B(71)-B(74)-B(75)-B(81)
! JVS(129) = Jac_FULL(30,31)
  JVS(129) = B(58)
! JVS(130) = Jac_FULL(30,37)
  JVS(130) = B(126)
! JVS(131) = Jac_FULL(30,38)
  JVS(131) = -B(76)
! JVS(132) = Jac_FULL(30,40)
  JVS(132) = B(127)
! JVS(133) = Jac_FULL(30,43)
  JVS(133) = -B(72)+B(78)
! JVS(134) = Jac_FULL(30,45)
  JVS(134) = B(59)
! JVS(135) = Jac_FULL(30,47)
  JVS(135) = 0
! JVS(136) = Jac_FULL(31,4)
  JVS(136) = B(52)
! JVS(137) = Jac_FULL(31,26)
  JVS(137) = B(68)
! JVS(138) = Jac_FULL(31,31)
  JVS(138) = -B(54)-B(56)-B(58)-B(60)-B(62)-B(64)-B(66)
! JVS(139) = Jac_FULL(31,38)
  JVS(139) = -B(65)-B(67)
! JVS(140) = Jac_FULL(31,40)
  JVS(140) = -B(61)-B(63)
! JVS(141) = Jac_FULL(31,43)
  JVS(141) = B(53)
! JVS(142) = Jac_FULL(31,45)
  JVS(142) = -B(57)-B(59)
! JVS(143) = Jac_FULL(31,47)
  JVS(143) = -B(55)+B(69)
! JVS(144) = Jac_FULL(32,1)
  JVS(144) = 0.63*B(194)
! JVS(145) = Jac_FULL(32,14)
  JVS(145) = B(207)
! JVS(146) = Jac_FULL(32,23)
  JVS(146) = 0
! JVS(147) = Jac_FULL(32,27)
  JVS(147) = 0
! JVS(148) = Jac_FULL(32,32)
  JVS(148) = -B(108)-B(160)
! JVS(149) = Jac_FULL(32,33)
  JVS(149) = 0.17*B(184)
! JVS(150) = Jac_FULL(32,34)
  JVS(150) = B(230)
! JVS(151) = Jac_FULL(32,36)
  JVS(151) = 0.17*B(185)+0.7*B(192)
! JVS(152) = Jac_FULL(32,41)
  JVS(152) = 0
! JVS(153) = Jac_FULL(32,42)
  JVS(153) = B(106)
! JVS(154) = Jac_FULL(32,43)
  JVS(154) = B(104)-B(109)
! JVS(155) = Jac_FULL(32,44)
  JVS(155) = B(151)-B(161)
! JVS(156) = Jac_FULL(32,46)
  JVS(156) = B(105)+B(107)+0.7*B(193)+B(223)+B(224)
! JVS(157) = Jac_FULL(32,47)
  JVS(157) = 0
! JVS(158) = Jac_FULL(33,5)
  JVS(158) = B(86)
! JVS(159) = Jac_FULL(33,33)
  JVS(159) = -B(180)-B(182)-B(184)
! JVS(160) = Jac_FULL(33,36)
  JVS(160) = -B(185)+0.75*B(188)
! JVS(161) = Jac_FULL(33,37)
  JVS(161) = 0.75*B(189)
! JVS(162) = Jac_FULL(33,43)
  JVS(162) = B(87)
! JVS(163) = Jac_FULL(33,47)
  JVS(163) = -B(183)
! JVS(164) = Jac_FULL(34,11)
  JVS(164) = B(147)
! JVS(165) = Jac_FULL(34,25)
  JVS(165) = B(178)+0.333*B(231)
! JVS(166) = Jac_FULL(34,28)
  JVS(166) = B(145)+B(228)
! JVS(167) = Jac_FULL(34,34)
  JVS(167) = -B(110)+B(162)-B(230)
! JVS(168) = Jac_FULL(34,35)
  JVS(168) = 0.5*B(135)+B(137)+B(139)+B(141)+0.5*B(142)
! JVS(169) = Jac_FULL(34,38)
  JVS(169) = 0
! JVS(170) = Jac_FULL(34,40)
  JVS(170) = B(138)
! JVS(171) = Jac_FULL(34,41)
  JVS(171) = 0
! JVS(172) = Jac_FULL(34,42)
  JVS(172) = B(140)
! JVS(173) = Jac_FULL(34,43)
  JVS(173) = -B(111)+B(146)+B(148)+B(179)
! JVS(174) = Jac_FULL(34,44)
  JVS(174) = B(163)
! JVS(175) = Jac_FULL(34,45)
  JVS(175) = 0.5*B(136)
! JVS(176) = Jac_FULL(35,25)
  JVS(176) = B(177)+0.667*B(231)
! JVS(177) = Jac_FULL(35,28)
  JVS(177) = B(143)
! JVS(178) = Jac_FULL(35,35)
  JVS(178) = -B(134)-B(135)-B(137)-B(139)-B(141)-B(142)-B(175)
! JVS(179) = Jac_FULL(35,38)
  JVS(179) = -B(176)
! JVS(180) = Jac_FULL(35,40)
  JVS(180) = -B(138)
! JVS(181) = Jac_FULL(35,41)
  JVS(181) = 0
! JVS(182) = Jac_FULL(35,42)
  JVS(182) = -B(140)
! JVS(183) = Jac_FULL(35,43)
  JVS(183) = B(144)
! JVS(184) = Jac_FULL(35,44)
  JVS(184) = 0
! JVS(185) = Jac_FULL(35,45)
  JVS(185) = B(132)-B(136)
! JVS(186) = Jac_FULL(35,46)
  JVS(186) = B(133)
! JVS(187) = Jac_FULL(36,14)
  JVS(187) = B(205)
! JVS(188) = Jac_FULL(36,23)
  JVS(188) = B(1)+B(22)+B(197)
! JVS(189) = Jac_FULL(36,27)
  JVS(189) = B(198)-B(203)
! JVS(190) = Jac_FULL(36,33)
  JVS(190) = -B(184)
! JVS(191) = Jac_FULL(36,36)
  JVS(191) = -B(3)-B(185)-B(188)-B(190)-B(192)-B(204)
! JVS(192) = Jac_FULL(36,37)
  JVS(192) = -B(189)
! JVS(193) = Jac_FULL(36,38)
  JVS(193) = B(215)
! JVS(194) = Jac_FULL(36,39)
  JVS(194) = -B(191)
! JVS(195) = Jac_FULL(36,41)
  JVS(195) = 0
! JVS(196) = Jac_FULL(36,42)
  JVS(196) = B(216)
! JVS(197) = Jac_FULL(36,43)
  JVS(197) = 0
! JVS(198) = Jac_FULL(36,46)
  JVS(198) = -B(193)
! JVS(199) = Jac_FULL(36,47)
  JVS(199) = B(213)
! JVS(200) = Jac_FULL(37,18)
  JVS(200) = B(222)
! JVS(201) = Jac_FULL(37,19)
  JVS(201) = B(225)
! JVS(202) = Jac_FULL(37,21)
  JVS(202) = 0.15*B(88)
! JVS(203) = Jac_FULL(37,24)
  JVS(203) = 0.333*B(227)
! JVS(204) = Jac_FULL(37,29)
  JVS(204) = B(226)
! JVS(205) = Jac_FULL(37,33)
  JVS(205) = 0.044*B(182)
! JVS(206) = Jac_FULL(37,36)
  JVS(206) = -B(188)+B(190)
! JVS(207) = Jac_FULL(37,37)
  JVS(207) = -B(119)-B(120)-B(122)-B(124)-B(126)-B(186)-B(189)
! JVS(208) = Jac_FULL(37,38)
  JVS(208) = -B(121)-B(123)
! JVS(209) = Jac_FULL(37,39)
  JVS(209) = B(94)+B(98)+B(100)+B(128)+B(149)+B(191)
! JVS(210) = Jac_FULL(37,40)
  JVS(210) = B(95)-B(125)-B(127)
! JVS(211) = Jac_FULL(37,41)
  JVS(211) = 0
! JVS(212) = Jac_FULL(37,42)
  JVS(212) = B(99)
! JVS(213) = Jac_FULL(37,43)
  JVS(213) = 0.15*B(89)+B(150)
! JVS(214) = Jac_FULL(37,44)
  JVS(214) = 0
! JVS(215) = Jac_FULL(37,45)
  JVS(215) = 0
! JVS(216) = Jac_FULL(37,46)
  JVS(216) = 0
! JVS(217) = Jac_FULL(37,47)
  JVS(217) = B(129)+0.044*B(183)-B(187)
! JVS(218) = Jac_FULL(38,6)
  JVS(218) = B(32)+B(218)
! JVS(219) = Jac_FULL(38,10)
  JVS(219) = B(83)
! JVS(220) = Jac_FULL(38,17)
  JVS(220) = B(49)+B(50)+0.667*B(221)
! JVS(221) = Jac_FULL(38,20)
  JVS(221) = B(220)
! JVS(222) = Jac_FULL(38,22)
  JVS(222) = B(45)
! JVS(223) = Jac_FULL(38,24)
  JVS(223) = B(114)+0.667*B(227)
! JVS(224) = Jac_FULL(38,25)
  JVS(224) = B(177)+0.667*B(231)
! JVS(225) = Jac_FULL(38,29)
  JVS(225) = B(117)+B(226)
! JVS(226) = Jac_FULL(38,30)
  JVS(226) = -B(75)
! JVS(227) = Jac_FULL(38,31)
  JVS(227) = -B(64)-B(66)
! JVS(228) = Jac_FULL(38,35)
  JVS(228) = B(137)+B(139)-B(175)
! JVS(229) = Jac_FULL(38,37)
  JVS(229) = -B(120)-B(122)
! JVS(230) = Jac_FULL(38,38)
  JVS(230) = -B(26)-B(30)-B(37)-B(39)-B(41)-B(65)-B(67)-B(76)-B(112)-B(121)-B(123)-B(158)-B(176)-B(215)
! JVS(231) = Jac_FULL(38,39)
  JVS(231) = B(94)+B(98)-B(113)
! JVS(232) = Jac_FULL(38,40)
  JVS(232) = B(24)+2*B(28)+B(35)+B(95)+B(138)+B(156)
! JVS(233) = Jac_FULL(38,41)
  JVS(233) = 0
! JVS(234) = Jac_FULL(38,42)
  JVS(234) = 2*B(29)-B(31)+B(43)+B(99)+B(140)+B(216)
! JVS(235) = Jac_FULL(38,43)
  JVS(235) = -B(38)-B(40)+B(46)+B(51)+B(118)
! JVS(236) = Jac_FULL(38,44)
  JVS(236) = B(157)-B(159)
! JVS(237) = Jac_FULL(38,45)
  JVS(237) = B(36)-B(42)+B(44)
! JVS(238) = Jac_FULL(38,46)
  JVS(238) = 0
! JVS(239) = Jac_FULL(38,47)
  JVS(239) = B(25)-B(27)
! JVS(240) = Jac_FULL(39,18)
  JVS(240) = 0.6*B(102)
! JVS(241) = Jac_FULL(39,24)
  JVS(241) = B(114)+0.667*B(227)
! JVS(242) = Jac_FULL(39,33)
  JVS(242) = B(180)
! JVS(243) = Jac_FULL(39,36)
  JVS(243) = -B(190)
! JVS(244) = Jac_FULL(39,37)
  JVS(244) = B(186)
! JVS(245) = Jac_FULL(39,38)
  JVS(245) = -B(112)
! JVS(246) = Jac_FULL(39,39)
  JVS(246) = -B(90)-B(92)-B(94)-B(96)-B(98)-B(100)-B(101)-B(113)-B(128)-B(149)-B(168)-B(191)-B(229)
! JVS(247) = Jac_FULL(39,40)
  JVS(247) = -B(95)-B(97)
! JVS(248) = Jac_FULL(39,41)
  JVS(248) = 0
! JVS(249) = Jac_FULL(39,42)
  JVS(249) = -B(99)
! JVS(250) = Jac_FULL(39,43)
  JVS(250) = 0.6*B(103)-B(150)
! JVS(251) = Jac_FULL(39,44)
  JVS(251) = -B(169)
! JVS(252) = Jac_FULL(39,45)
  JVS(252) = -B(91)-B(93)
! JVS(253) = Jac_FULL(39,46)
  JVS(253) = 0
! JVS(254) = Jac_FULL(39,47)
  JVS(254) = -B(129)+B(187)
! JVS(255) = Jac_FULL(40,7)
  JVS(255) = B(209)
! JVS(256) = Jac_FULL(40,14)
  JVS(256) = B(207)
! JVS(257) = Jac_FULL(40,15)
  JVS(257) = B(73)
! JVS(258) = Jac_FULL(40,19)
  JVS(258) = B(130)+B(225)
! JVS(259) = Jac_FULL(40,22)
  JVS(259) = B(219)
! JVS(260) = Jac_FULL(40,23)
  JVS(260) = 0
! JVS(261) = Jac_FULL(40,26)
  JVS(261) = 0
! JVS(262) = Jac_FULL(40,27)
  JVS(262) = 0
! JVS(263) = Jac_FULL(40,30)
  JVS(263) = B(71)+B(74)+B(75)+B(81)
! JVS(264) = Jac_FULL(40,31)
  JVS(264) = -B(60)-B(62)+B(66)
! JVS(265) = Jac_FULL(40,35)
  JVS(265) = -B(137)
! JVS(266) = Jac_FULL(40,36)
  JVS(266) = 0
! JVS(267) = Jac_FULL(40,37)
  JVS(267) = -B(124)-B(126)
! JVS(268) = Jac_FULL(40,38)
  JVS(268) = B(67)+B(76)+B(215)
! JVS(269) = Jac_FULL(40,39)
  JVS(269) = -B(94)-B(96)
! JVS(270) = Jac_FULL(40,40)
  JVS(270) = -B(24)-B(28)-B(33)-B(35)-B(61)-B(63)-B(95)-B(97)-B(125)-B(127)-B(138)-B(156)
! JVS(271) = Jac_FULL(40,41)
  JVS(271) = 0
! JVS(272) = Jac_FULL(40,42)
  JVS(272) = -B(29)+B(217)
! JVS(273) = Jac_FULL(40,43)
  JVS(273) = -B(34)+B(72)+B(131)
! JVS(274) = Jac_FULL(40,44)
  JVS(274) = -B(157)
! JVS(275) = Jac_FULL(40,45)
  JVS(275) = -B(36)
! JVS(276) = Jac_FULL(40,46)
  JVS(276) = 0
! JVS(277) = Jac_FULL(40,47)
  JVS(277) = -B(25)
! JVS(278) = Jac_FULL(41,1)
  JVS(278) = 0.47*B(194)
! JVS(279) = Jac_FULL(41,4)
  JVS(279) = B(52)
! JVS(280) = Jac_FULL(41,5)
  JVS(280) = B(86)
! JVS(281) = Jac_FULL(41,8)
  JVS(281) = B(18)
! JVS(282) = Jac_FULL(41,9)
  JVS(282) = 2*B(21)+B(154)
! JVS(283) = Jac_FULL(41,10)
  JVS(283) = B(84)
! JVS(284) = Jac_FULL(41,11)
  JVS(284) = B(147)
! JVS(285) = Jac_FULL(41,12)
  JVS(285) = B(79)
! JVS(286) = Jac_FULL(41,15)
  JVS(286) = B(77)
! JVS(287) = Jac_FULL(41,16)
  JVS(287) = B(9)
! JVS(288) = Jac_FULL(41,17)
  JVS(288) = B(50)
! JVS(289) = Jac_FULL(41,18)
  JVS(289) = B(102)
! JVS(290) = Jac_FULL(41,19)
  JVS(290) = B(130)
! JVS(291) = Jac_FULL(41,20)
  JVS(291) = B(47)
! JVS(292) = Jac_FULL(41,21)
  JVS(292) = B(88)
! JVS(293) = Jac_FULL(41,22)
  JVS(293) = B(45)
! JVS(294) = Jac_FULL(41,23)
  JVS(294) = -B(16)
! JVS(295) = Jac_FULL(41,24)
  JVS(295) = B(115)
! JVS(296) = Jac_FULL(41,25)
  JVS(296) = B(178)
! JVS(297) = Jac_FULL(41,26)
  JVS(297) = 0
! JVS(298) = Jac_FULL(41,27)
  JVS(298) = B(195)
! JVS(299) = Jac_FULL(41,28)
  JVS(299) = B(143)+B(145)
! JVS(300) = Jac_FULL(41,29)
  JVS(300) = B(117)
! JVS(301) = Jac_FULL(41,30)
  JVS(301) = B(71)
! JVS(302) = Jac_FULL(41,31)
  JVS(302) = B(58)+B(62)+B(64)
! JVS(303) = Jac_FULL(41,33)
  JVS(303) = 0
! JVS(304) = Jac_FULL(41,34)
  JVS(304) = B(110)
! JVS(305) = Jac_FULL(41,35)
  JVS(305) = 0.3*B(135)
! JVS(306) = Jac_FULL(41,36)
  JVS(306) = 0
! JVS(307) = Jac_FULL(41,37)
  JVS(307) = 0
! JVS(308) = Jac_FULL(41,38)
  JVS(308) = B(65)
! JVS(309) = Jac_FULL(41,39)
  JVS(309) = B(92)
! JVS(310) = Jac_FULL(41,40)
  JVS(310) = B(63)
! JVS(311) = Jac_FULL(41,41)
  JVS(311) = -B(17)-2*B(20)-B(152)
! JVS(312) = Jac_FULL(41,42)
  JVS(312) = 0
! JVS(313) = Jac_FULL(41,43)
  JVS(313) = B(10)+B(13)+B(19)+B(46)+B(48)+B(51)+B(53)+B(72)+B(78)+B(80)+B(85)+B(87)+B(89)+B(103)+B(104)+B(111)+B(116)&
               &+B(118)+B(131)+B(144)+B(146)+B(148)+B(179)+B(196)
! JVS(314) = Jac_FULL(41,44)
  JVS(314) = -B(153)+B(155)
! JVS(315) = Jac_FULL(41,45)
  JVS(315) = B(14)+B(59)+B(93)+0.3*B(136)
! JVS(316) = Jac_FULL(41,46)
  JVS(316) = B(105)
! JVS(317) = Jac_FULL(41,47)
  JVS(317) = 0
! JVS(318) = Jac_FULL(42,6)
  JVS(318) = B(32)+B(218)
! JVS(319) = Jac_FULL(42,10)
  JVS(319) = B(84)
! JVS(320) = Jac_FULL(42,17)
  JVS(320) = 0.333*B(221)
! JVS(321) = Jac_FULL(42,20)
  JVS(321) = B(47)
! JVS(322) = Jac_FULL(42,24)
  JVS(322) = B(115)+0.333*B(227)
! JVS(323) = Jac_FULL(42,25)
  JVS(323) = B(178)+0.333*B(231)
! JVS(324) = Jac_FULL(42,35)
  JVS(324) = -B(139)
! JVS(325) = Jac_FULL(42,38)
  JVS(325) = B(26)-B(30)+B(158)
! JVS(326) = Jac_FULL(42,39)
  JVS(326) = -B(98)
! JVS(327) = Jac_FULL(42,40)
  JVS(327) = -B(28)
! JVS(328) = Jac_FULL(42,41)
  JVS(328) = 0
! JVS(329) = Jac_FULL(42,42)
  JVS(329) = -B(29)-B(31)-B(43)-B(99)-B(106)-B(140)-B(216)-B(217)
! JVS(330) = Jac_FULL(42,43)
  JVS(330) = B(48)+B(85)+B(116)+B(179)
! JVS(331) = Jac_FULL(42,44)
  JVS(331) = B(159)
! JVS(332) = Jac_FULL(42,45)
  JVS(332) = -B(44)
! JVS(333) = Jac_FULL(42,46)
  JVS(333) = -B(107)
! JVS(334) = Jac_FULL(42,47)
  JVS(334) = B(27)
! JVS(335) = Jac_FULL(43,1)
  JVS(335) = 0.16*B(194)
! JVS(336) = Jac_FULL(43,4)
  JVS(336) = -B(52)
! JVS(337) = Jac_FULL(43,5)
  JVS(337) = -B(86)
! JVS(338) = Jac_FULL(43,8)
  JVS(338) = -B(18)+2*B(214)
! JVS(339) = Jac_FULL(43,10)
  JVS(339) = B(83)-B(84)
! JVS(340) = Jac_FULL(43,11)
  JVS(340) = -B(147)
! JVS(341) = Jac_FULL(43,12)
  JVS(341) = -B(79)
! JVS(342) = Jac_FULL(43,15)
  JVS(342) = -B(77)
! JVS(343) = Jac_FULL(43,16)
  JVS(343) = -B(9)
! JVS(344) = Jac_FULL(43,17)
  JVS(344) = -B(50)+0.333*B(221)
! JVS(345) = Jac_FULL(43,18)
  JVS(345) = -0.6*B(102)+B(222)
! JVS(346) = Jac_FULL(43,19)
  JVS(346) = -B(130)
! JVS(347) = Jac_FULL(43,20)
  JVS(347) = -B(47)+B(220)
! JVS(348) = Jac_FULL(43,21)
  JVS(348) = -B(88)
! JVS(349) = Jac_FULL(43,22)
  JVS(349) = -B(45)+B(219)
! JVS(350) = Jac_FULL(43,23)
  JVS(350) = 2*B(16)+B(201)
! JVS(351) = Jac_FULL(43,24)
  JVS(351) = -B(115)
! JVS(352) = Jac_FULL(43,25)
  JVS(352) = -B(178)
! JVS(353) = Jac_FULL(43,26)
  JVS(353) = 0
! JVS(354) = Jac_FULL(43,27)
  JVS(354) = -B(195)+B(202)
! JVS(355) = Jac_FULL(43,28)
  JVS(355) = -B(143)+B(228)
! JVS(356) = Jac_FULL(43,29)
  JVS(356) = -B(117)
! JVS(357) = Jac_FULL(43,30)
  JVS(357) = -B(71)
! JVS(358) = Jac_FULL(43,31)
  JVS(358) = B(56)+B(60)
! JVS(359) = Jac_FULL(43,32)
  JVS(359) = -B(108)
! JVS(360) = Jac_FULL(43,33)
  JVS(360) = 0
! JVS(361) = Jac_FULL(43,34)
  JVS(361) = -B(110)+B(230)
! JVS(362) = Jac_FULL(43,35)
  JVS(362) = 0.2*B(135)
! JVS(363) = Jac_FULL(43,36)
  JVS(363) = 0.25*B(188)+0.7*B(192)
! JVS(364) = Jac_FULL(43,37)
  JVS(364) = 0.25*B(189)
! JVS(365) = Jac_FULL(43,38)
  JVS(365) = -B(37)-B(39)
! JVS(366) = Jac_FULL(43,39)
  JVS(366) = -B(149)+B(229)
! JVS(367) = Jac_FULL(43,40)
  JVS(367) = -B(33)+B(35)+B(61)
! JVS(368) = Jac_FULL(43,41)
  JVS(368) = 2*B(17)
! JVS(369) = Jac_FULL(43,42)
  JVS(369) = B(43)
! JVS(370) = Jac_FULL(43,43)
  JVS(370) = -B(7)-B(10)-B(13)-B(19)-B(34)-B(38)-B(40)-B(46)-B(48)-B(51)-B(53)-B(72)-B(78)-B(80)-B(85)-B(87)-B(89)-0.6&
               &*B(103)-B(104)-B(109)-B(111)-B(116)-B(118)-B(131)-B(144)-B(148)-B(150)-B(179)-B(196)
! JVS(371) = Jac_FULL(43,44)
  JVS(371) = B(151)
! JVS(372) = Jac_FULL(43,45)
  JVS(372) = B(11)-B(14)+B(36)+B(44)+B(57)+0.2*B(136)
! JVS(373) = Jac_FULL(43,46)
  JVS(373) = -B(105)+0.7*B(193)
! JVS(374) = Jac_FULL(43,47)
  JVS(374) = -B(8)+B(12)
! JVS(375) = Jac_FULL(44,1)
  JVS(375) = 0.37*B(194)
! JVS(376) = Jac_FULL(44,9)
  JVS(376) = -B(154)
! JVS(377) = Jac_FULL(44,21)
  JVS(377) = -B(166)
! JVS(378) = Jac_FULL(44,32)
  JVS(378) = -B(160)
! JVS(379) = Jac_FULL(44,33)
  JVS(379) = 0
! JVS(380) = Jac_FULL(44,34)
  JVS(380) = -B(162)
! JVS(381) = Jac_FULL(44,35)
  JVS(381) = 0
! JVS(382) = Jac_FULL(44,36)
  JVS(382) = 0
! JVS(383) = Jac_FULL(44,37)
  JVS(383) = 0
! JVS(384) = Jac_FULL(44,38)
  JVS(384) = -B(158)
! JVS(385) = Jac_FULL(44,39)
  JVS(385) = -B(168)
! JVS(386) = Jac_FULL(44,40)
  JVS(386) = -B(156)
! JVS(387) = Jac_FULL(44,41)
  JVS(387) = -B(152)
! JVS(388) = Jac_FULL(44,42)
  JVS(388) = 0
! JVS(389) = Jac_FULL(44,43)
  JVS(389) = 0
! JVS(390) = Jac_FULL(44,44)
  JVS(390) = -B(151)-B(153)-B(155)-B(157)-B(159)-B(161)-B(163)-B(164)-B(167)-B(169)-B(170)-B(172)-2*B(174)
! JVS(391) = Jac_FULL(44,45)
  JVS(391) = -B(171)
! JVS(392) = Jac_FULL(44,46)
  JVS(392) = -B(165)
! JVS(393) = Jac_FULL(44,47)
  JVS(393) = -B(173)
! JVS(394) = Jac_FULL(45,1)
  JVS(394) = 0.16*B(194)
! JVS(395) = Jac_FULL(45,8)
  JVS(395) = B(18)
! JVS(396) = Jac_FULL(45,11)
  JVS(396) = B(147)
! JVS(397) = Jac_FULL(45,13)
  JVS(397) = B(5)
! JVS(398) = Jac_FULL(45,16)
  JVS(398) = 0
! JVS(399) = Jac_FULL(45,17)
  JVS(399) = B(49)+0.667*B(221)
! JVS(400) = Jac_FULL(45,21)
  JVS(400) = 0.85*B(88)
! JVS(401) = Jac_FULL(45,23)
  JVS(401) = 0
! JVS(402) = Jac_FULL(45,25)
  JVS(402) = 0.333*B(231)
! JVS(403) = Jac_FULL(45,27)
  JVS(403) = 0
! JVS(404) = Jac_FULL(45,28)
  JVS(404) = B(228)
! JVS(405) = Jac_FULL(45,30)
  JVS(405) = B(81)
! JVS(406) = Jac_FULL(45,31)
  JVS(406) = -B(56)-B(58)+B(60)
! JVS(407) = Jac_FULL(45,32)
  JVS(407) = 0
! JVS(408) = Jac_FULL(45,33)
  JVS(408) = 0
! JVS(409) = Jac_FULL(45,34)
  JVS(409) = B(110)+B(230)
! JVS(410) = Jac_FULL(45,35)
  JVS(410) = B(134)-0.8*B(135)+B(137)+B(139)+B(141)
! JVS(411) = Jac_FULL(45,36)
  JVS(411) = B(192)
! JVS(412) = Jac_FULL(45,37)
  JVS(412) = B(119)
! JVS(413) = Jac_FULL(45,38)
  JVS(413) = -B(41)
! JVS(414) = Jac_FULL(45,39)
  JVS(414) = -B(90)-B(92)+B(149)
! JVS(415) = Jac_FULL(45,40)
  JVS(415) = -B(35)+B(61)+B(138)
! JVS(416) = Jac_FULL(45,41)
  JVS(416) = 0
! JVS(417) = Jac_FULL(45,42)
  JVS(417) = -B(43)+B(106)+B(140)
! JVS(418) = Jac_FULL(45,43)
  JVS(418) = B(7)-B(13)+B(19)+0.85*B(89)+B(104)+B(111)+B(148)+B(150)
! JVS(419) = Jac_FULL(45,44)
  JVS(419) = B(151)-B(170)
! JVS(420) = Jac_FULL(45,45)
  JVS(420) = -B(11)-B(14)-2*B(15)-B(36)-B(42)-B(44)-B(57)-B(59)-B(91)-B(93)-B(132)-0.8*B(136)-B(171)
! JVS(421) = Jac_FULL(45,46)
  JVS(421) = B(105)+B(107)-B(133)+B(193)+B(224)
! JVS(422) = Jac_FULL(45,47)
  JVS(422) = B(8)-B(12)
! JVS(423) = Jac_FULL(46,18)
  JVS(423) = 0.4*B(102)
! JVS(424) = Jac_FULL(46,19)
  JVS(424) = B(130)
! JVS(425) = Jac_FULL(46,21)
  JVS(425) = 0.85*B(88)
! JVS(426) = Jac_FULL(46,24)
  JVS(426) = B(115)
! JVS(427) = Jac_FULL(46,29)
  JVS(427) = B(117)
! JVS(428) = Jac_FULL(46,32)
  JVS(428) = B(160)
! JVS(429) = Jac_FULL(46,33)
  JVS(429) = 0.956*B(182)+0.83*B(184)
! JVS(430) = Jac_FULL(46,34)
  JVS(430) = 0
! JVS(431) = Jac_FULL(46,35)
  JVS(431) = B(134)
! JVS(432) = Jac_FULL(46,36)
  JVS(432) = 0.83*B(185)+0.25*B(188)-B(192)
! JVS(433) = Jac_FULL(46,37)
  JVS(433) = B(119)+B(122)+B(126)+0.25*B(189)
! JVS(434) = Jac_FULL(46,38)
  JVS(434) = B(123)+B(158)
! JVS(435) = Jac_FULL(46,39)
  JVS(435) = B(92)+0.5*B(101)+B(229)
! JVS(436) = Jac_FULL(46,40)
  JVS(436) = B(127)+B(156)
! JVS(437) = Jac_FULL(46,41)
  JVS(437) = 0
! JVS(438) = Jac_FULL(46,42)
  JVS(438) = -B(106)
! JVS(439) = Jac_FULL(46,43)
  JVS(439) = 0.85*B(89)+0.4*B(103)-B(104)+B(116)+B(118)+B(131)
! JVS(440) = Jac_FULL(46,44)
  JVS(440) = B(157)+B(159)+B(161)-B(164)+B(172)+2*B(174)
! JVS(441) = Jac_FULL(46,45)
  JVS(441) = B(93)-B(132)
! JVS(442) = Jac_FULL(46,46)
  JVS(442) = -B(105)-B(107)-B(133)-B(165)-B(193)-B(223)-B(224)
! JVS(443) = Jac_FULL(46,47)
  JVS(443) = B(173)+0.956*B(183)
! JVS(444) = Jac_FULL(47,26)
  JVS(444) = -B(68)
! JVS(445) = Jac_FULL(47,31)
  JVS(445) = -B(54)
! JVS(446) = Jac_FULL(47,33)
  JVS(446) = -B(182)
! JVS(447) = Jac_FULL(47,36)
  JVS(447) = B(3)
! JVS(448) = Jac_FULL(47,37)
  JVS(448) = -B(186)
! JVS(449) = Jac_FULL(47,38)
  JVS(449) = -B(26)
! JVS(450) = Jac_FULL(47,39)
  JVS(450) = -B(128)
! JVS(451) = Jac_FULL(47,40)
  JVS(451) = -B(24)
! JVS(452) = Jac_FULL(47,41)
  JVS(452) = 0
! JVS(453) = Jac_FULL(47,42)
  JVS(453) = 0
! JVS(454) = Jac_FULL(47,43)
  JVS(454) = -B(7)
! JVS(455) = Jac_FULL(47,44)
  JVS(455) = -B(172)
! JVS(456) = Jac_FULL(47,45)
  JVS(456) = -B(11)
! JVS(457) = Jac_FULL(47,46)
  JVS(457) = 0
! JVS(458) = Jac_FULL(47,47)
  JVS(458) = -B(8)-B(12)-B(25)-B(27)-B(55)-B(69)-B(129)-B(173)-B(183)-B(187)-B(212)-B(213)
      
END SUBROUTINE Jac_SP

! End of Jac_SP function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR)

  JUV(1) = JVS(1)*UV(1)
  JUV(2) = JVS(2)*UV(2)+JVS(3)*UV(31)+JVS(4)*UV(38)
  JUV(3) = JVS(5)*UV(3)+JVS(6)*UV(21)+JVS(7)*UV(39)+JVS(8)*UV(44)+JVS(9)*UV(45)+JVS(10)*UV(46)
  JUV(4) = JVS(11)*UV(4)+JVS(12)*UV(43)
  JUV(5) = JVS(13)*UV(5)+JVS(14)*UV(43)
  JUV(6) = JVS(15)*UV(6)+JVS(16)*UV(38)+JVS(17)*UV(42)
  JUV(7) = JVS(18)*UV(7)+JVS(19)*UV(14)+JVS(20)*UV(23)+JVS(21)*UV(27)+JVS(22)*UV(36)
  JUV(8) = JVS(23)*UV(8)+JVS(24)*UV(43)+JVS(25)*UV(45)
  JUV(9) = JVS(26)*UV(9)+JVS(27)*UV(41)+JVS(28)*UV(44)
  JUV(10) = JVS(29)*UV(10)+JVS(30)*UV(38)+JVS(31)*UV(43)
  JUV(11) = JVS(32)*UV(11)+JVS(33)*UV(35)+JVS(34)*UV(43)
  JUV(12) = JVS(35)*UV(12)+JVS(36)*UV(15)+JVS(37)*UV(30)+JVS(38)*UV(43)
  JUV(13) = JVS(39)*UV(13)+JVS(40)*UV(16)+JVS(41)*UV(23)+JVS(42)*UV(27)+JVS(43)*UV(32)+JVS(44)*UV(33)+JVS(45)*UV(36)&
              &+JVS(46)*UV(43)+JVS(47)*UV(46)+JVS(48)*UV(47)
  JUV(14) = JVS(49)*UV(14)+JVS(50)*UV(23)+JVS(51)*UV(27)+JVS(52)*UV(43)
  JUV(15) = JVS(53)*UV(12)+JVS(54)*UV(15)+JVS(55)*UV(26)+JVS(56)*UV(30)+JVS(57)*UV(43)
  JUV(16) = JVS(58)*UV(16)+JVS(59)*UV(33)+JVS(60)*UV(36)+JVS(61)*UV(43)+JVS(62)*UV(46)
  JUV(17) = JVS(63)*UV(17)+JVS(64)*UV(38)+JVS(65)*UV(43)+JVS(66)*UV(45)
  JUV(18) = JVS(67)*UV(18)+JVS(68)*UV(39)+JVS(69)*UV(43)+JVS(70)*UV(45)
  JUV(19) = JVS(71)*UV(19)+JVS(72)*UV(37)+JVS(73)*UV(40)+JVS(74)*UV(43)
  JUV(20) = JVS(75)*UV(20)+JVS(76)*UV(38)+JVS(77)*UV(42)+JVS(78)*UV(43)+JVS(79)*UV(46)
  JUV(21) = JVS(80)*UV(21)+JVS(81)*UV(39)+JVS(82)*UV(43)+JVS(83)*UV(44)
  JUV(22) = JVS(84)*UV(22)+JVS(85)*UV(30)+JVS(86)*UV(37)+JVS(87)*UV(38)+JVS(88)*UV(40)+JVS(89)*UV(43)
  JUV(23) = JVS(90)*UV(23)+JVS(91)*UV(27)+JVS(92)*UV(41)+JVS(93)*UV(47)
  JUV(24) = JVS(94)*UV(24)+JVS(95)*UV(38)+JVS(96)*UV(39)+JVS(97)*UV(43)
  JUV(25) = JVS(98)*UV(25)+JVS(99)*UV(35)+JVS(100)*UV(38)+JVS(101)*UV(43)
  JUV(26) = JVS(102)*UV(26)+JVS(103)*UV(31)+JVS(104)*UV(38)+JVS(105)*UV(45)+JVS(106)*UV(47)
  JUV(27) = JVS(107)*UV(23)+JVS(108)*UV(27)+JVS(109)*UV(36)+JVS(111)*UV(43)
  JUV(28) = JVS(113)*UV(9)+JVS(114)*UV(28)+JVS(115)*UV(35)+JVS(116)*UV(41)+JVS(117)*UV(43)+JVS(118)*UV(44)+JVS(119)&
              &*UV(45)
  JUV(29) = JVS(120)*UV(29)+JVS(121)*UV(37)+JVS(122)*UV(38)+JVS(123)*UV(39)+JVS(124)*UV(40)+JVS(125)*UV(43)
  JUV(30) = JVS(126)*UV(15)+JVS(128)*UV(30)+JVS(129)*UV(31)+JVS(130)*UV(37)+JVS(131)*UV(38)+JVS(132)*UV(40)+JVS(133)&
              &*UV(43)+JVS(134)*UV(45)
  JUV(31) = JVS(136)*UV(4)+JVS(137)*UV(26)+JVS(138)*UV(31)+JVS(139)*UV(38)+JVS(140)*UV(40)+JVS(141)*UV(43)+JVS(142)&
              &*UV(45)+JVS(143)*UV(47)
  JUV(32) = JVS(144)*UV(1)+JVS(145)*UV(14)+JVS(148)*UV(32)+JVS(149)*UV(33)+JVS(150)*UV(34)+JVS(151)*UV(36)+JVS(153)&
              &*UV(42)+JVS(154)*UV(43)+JVS(155)*UV(44)+JVS(156)*UV(46)
  JUV(33) = JVS(158)*UV(5)+JVS(159)*UV(33)+JVS(160)*UV(36)+JVS(161)*UV(37)+JVS(162)*UV(43)+JVS(163)*UV(47)
  JUV(34) = JVS(164)*UV(11)+JVS(165)*UV(25)+JVS(166)*UV(28)+JVS(167)*UV(34)+JVS(168)*UV(35)+JVS(170)*UV(40)+JVS(172)&
              &*UV(42)+JVS(173)*UV(43)+JVS(174)*UV(44)+JVS(175)*UV(45)
  JUV(35) = JVS(176)*UV(25)+JVS(177)*UV(28)+JVS(178)*UV(35)+JVS(179)*UV(38)+JVS(180)*UV(40)+JVS(182)*UV(42)+JVS(183)&
              &*UV(43)+JVS(185)*UV(45)+JVS(186)*UV(46)
  JUV(36) = JVS(187)*UV(14)+JVS(188)*UV(23)+JVS(189)*UV(27)+JVS(190)*UV(33)+JVS(191)*UV(36)+JVS(192)*UV(37)+JVS(193)&
              &*UV(38)+JVS(194)*UV(39)+JVS(196)*UV(42)+JVS(198)*UV(46)+JVS(199)*UV(47)
  JUV(37) = JVS(200)*UV(18)+JVS(201)*UV(19)+JVS(202)*UV(21)+JVS(203)*UV(24)+JVS(204)*UV(29)+JVS(205)*UV(33)+JVS(206)&
              &*UV(36)+JVS(207)*UV(37)+JVS(208)*UV(38)+JVS(209)*UV(39)+JVS(210)*UV(40)+JVS(212)*UV(42)+JVS(213)*UV(43)&
              &+JVS(217)*UV(47)
  JUV(38) = JVS(218)*UV(6)+JVS(219)*UV(10)+JVS(220)*UV(17)+JVS(221)*UV(20)+JVS(222)*UV(22)+JVS(223)*UV(24)+JVS(224)&
              &*UV(25)+JVS(225)*UV(29)+JVS(226)*UV(30)+JVS(227)*UV(31)+JVS(228)*UV(35)+JVS(229)*UV(37)+JVS(230)*UV(38)&
              &+JVS(231)*UV(39)+JVS(232)*UV(40)+JVS(234)*UV(42)+JVS(235)*UV(43)+JVS(236)*UV(44)+JVS(237)*UV(45)+JVS(239)&
              &*UV(47)
  JUV(39) = JVS(240)*UV(18)+JVS(241)*UV(24)+JVS(242)*UV(33)+JVS(243)*UV(36)+JVS(244)*UV(37)+JVS(245)*UV(38)+JVS(246)&
              &*UV(39)+JVS(247)*UV(40)+JVS(249)*UV(42)+JVS(250)*UV(43)+JVS(251)*UV(44)+JVS(252)*UV(45)+JVS(254)*UV(47)
  JUV(40) = JVS(255)*UV(7)+JVS(256)*UV(14)+JVS(257)*UV(15)+JVS(258)*UV(19)+JVS(259)*UV(22)+JVS(263)*UV(30)+JVS(264)&
              &*UV(31)+JVS(265)*UV(35)+JVS(267)*UV(37)+JVS(268)*UV(38)+JVS(269)*UV(39)+JVS(270)*UV(40)+JVS(272)*UV(42)&
              &+JVS(273)*UV(43)+JVS(274)*UV(44)+JVS(275)*UV(45)+JVS(277)*UV(47)
  JUV(41) = JVS(278)*UV(1)+JVS(279)*UV(4)+JVS(280)*UV(5)+JVS(281)*UV(8)+JVS(282)*UV(9)+JVS(283)*UV(10)+JVS(284)*UV(11)&
              &+JVS(285)*UV(12)+JVS(286)*UV(15)+JVS(287)*UV(16)+JVS(288)*UV(17)+JVS(289)*UV(18)+JVS(290)*UV(19)+JVS(291)&
              &*UV(20)+JVS(292)*UV(21)+JVS(293)*UV(22)+JVS(294)*UV(23)+JVS(295)*UV(24)+JVS(296)*UV(25)+JVS(298)*UV(27)&
              &+JVS(299)*UV(28)+JVS(300)*UV(29)+JVS(301)*UV(30)+JVS(302)*UV(31)+JVS(304)*UV(34)+JVS(305)*UV(35)+JVS(308)&
              &*UV(38)+JVS(309)*UV(39)+JVS(310)*UV(40)+JVS(311)*UV(41)+JVS(313)*UV(43)+JVS(314)*UV(44)+JVS(315)*UV(45)&
              &+JVS(316)*UV(46)
  JUV(42) = JVS(318)*UV(6)+JVS(319)*UV(10)+JVS(320)*UV(17)+JVS(321)*UV(20)+JVS(322)*UV(24)+JVS(323)*UV(25)+JVS(324)&
              &*UV(35)+JVS(325)*UV(38)+JVS(326)*UV(39)+JVS(327)*UV(40)+JVS(329)*UV(42)+JVS(330)*UV(43)+JVS(331)*UV(44)&
              &+JVS(332)*UV(45)+JVS(333)*UV(46)+JVS(334)*UV(47)
  JUV(43) = JVS(335)*UV(1)+JVS(336)*UV(4)+JVS(337)*UV(5)+JVS(338)*UV(8)+JVS(339)*UV(10)+JVS(340)*UV(11)+JVS(341)*UV(12)&
              &+JVS(342)*UV(15)+JVS(343)*UV(16)+JVS(344)*UV(17)+JVS(345)*UV(18)+JVS(346)*UV(19)+JVS(347)*UV(20)+JVS(348)&
              &*UV(21)+JVS(349)*UV(22)+JVS(350)*UV(23)+JVS(351)*UV(24)+JVS(352)*UV(25)+JVS(354)*UV(27)+JVS(355)*UV(28)&
              &+JVS(356)*UV(29)+JVS(357)*UV(30)+JVS(358)*UV(31)+JVS(359)*UV(32)+JVS(361)*UV(34)+JVS(362)*UV(35)+JVS(363)&
              &*UV(36)+JVS(364)*UV(37)+JVS(365)*UV(38)+JVS(366)*UV(39)+JVS(367)*UV(40)+JVS(368)*UV(41)+JVS(369)*UV(42)&
              &+JVS(370)*UV(43)+JVS(371)*UV(44)+JVS(372)*UV(45)+JVS(373)*UV(46)+JVS(374)*UV(47)
  JUV(44) = JVS(375)*UV(1)+JVS(376)*UV(9)+JVS(377)*UV(21)+JVS(378)*UV(32)+JVS(380)*UV(34)+JVS(384)*UV(38)+JVS(385)&
              &*UV(39)+JVS(386)*UV(40)+JVS(387)*UV(41)+JVS(390)*UV(44)+JVS(391)*UV(45)+JVS(392)*UV(46)+JVS(393)*UV(47)
  JUV(45) = JVS(394)*UV(1)+JVS(395)*UV(8)+JVS(396)*UV(11)+JVS(397)*UV(13)+JVS(399)*UV(17)+JVS(400)*UV(21)+JVS(402)&
              &*UV(25)+JVS(404)*UV(28)+JVS(405)*UV(30)+JVS(406)*UV(31)+JVS(409)*UV(34)+JVS(410)*UV(35)+JVS(411)*UV(36)&
              &+JVS(412)*UV(37)+JVS(413)*UV(38)+JVS(414)*UV(39)+JVS(415)*UV(40)+JVS(417)*UV(42)+JVS(418)*UV(43)+JVS(419)&
              &*UV(44)+JVS(420)*UV(45)+JVS(421)*UV(46)+JVS(422)*UV(47)
  JUV(46) = JVS(423)*UV(18)+JVS(424)*UV(19)+JVS(425)*UV(21)+JVS(426)*UV(24)+JVS(427)*UV(29)+JVS(428)*UV(32)+JVS(429)&
              &*UV(33)+JVS(431)*UV(35)+JVS(432)*UV(36)+JVS(433)*UV(37)+JVS(434)*UV(38)+JVS(435)*UV(39)+JVS(436)*UV(40)&
              &+JVS(438)*UV(42)+JVS(439)*UV(43)+JVS(440)*UV(44)+JVS(441)*UV(45)+JVS(442)*UV(46)+JVS(443)*UV(47)
  JUV(47) = JVS(444)*UV(26)+JVS(445)*UV(31)+JVS(446)*UV(33)+JVS(447)*UV(36)+JVS(448)*UV(37)+JVS(449)*UV(38)+JVS(450)&
              &*UV(39)+JVS(451)*UV(40)+JVS(454)*UV(43)+JVS(455)*UV(44)+JVS(456)*UV(45)+JVS(458)*UV(47)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR)

  JTUV(1) = JVS(1)*UV(1)+JVS(144)*UV(32)+JVS(278)*UV(41)+JVS(335)*UV(43)+JVS(375)*UV(44)+JVS(394)*UV(45)
  JTUV(2) = JVS(2)*UV(2)
  JTUV(3) = JVS(5)*UV(3)
  JTUV(4) = JVS(11)*UV(4)+JVS(136)*UV(31)+JVS(279)*UV(41)+JVS(336)*UV(43)
  JTUV(5) = JVS(13)*UV(5)+JVS(158)*UV(33)+JVS(280)*UV(41)+JVS(337)*UV(43)
  JTUV(6) = JVS(15)*UV(6)+JVS(218)*UV(38)+JVS(318)*UV(42)
  JTUV(7) = JVS(18)*UV(7)+JVS(255)*UV(40)
  JTUV(8) = JVS(23)*UV(8)+JVS(281)*UV(41)+JVS(338)*UV(43)+JVS(395)*UV(45)
  JTUV(9) = JVS(26)*UV(9)+JVS(113)*UV(28)+JVS(282)*UV(41)+JVS(376)*UV(44)
  JTUV(10) = JVS(29)*UV(10)+JVS(219)*UV(38)+JVS(283)*UV(41)+JVS(319)*UV(42)+JVS(339)*UV(43)
  JTUV(11) = JVS(32)*UV(11)+JVS(164)*UV(34)+JVS(284)*UV(41)+JVS(340)*UV(43)+JVS(396)*UV(45)
  JTUV(12) = JVS(35)*UV(12)+JVS(53)*UV(15)+JVS(285)*UV(41)+JVS(341)*UV(43)
  JTUV(13) = JVS(39)*UV(13)+JVS(397)*UV(45)
  JTUV(14) = JVS(19)*UV(7)+JVS(49)*UV(14)+JVS(145)*UV(32)+JVS(187)*UV(36)+JVS(256)*UV(40)
  JTUV(15) = JVS(36)*UV(12)+JVS(54)*UV(15)+JVS(126)*UV(30)+JVS(257)*UV(40)+JVS(286)*UV(41)+JVS(342)*UV(43)
  JTUV(16) = JVS(40)*UV(13)+JVS(58)*UV(16)+JVS(287)*UV(41)+JVS(343)*UV(43)
  JTUV(17) = JVS(63)*UV(17)+JVS(220)*UV(38)+JVS(288)*UV(41)+JVS(320)*UV(42)+JVS(344)*UV(43)+JVS(399)*UV(45)
  JTUV(18) = JVS(67)*UV(18)+JVS(200)*UV(37)+JVS(240)*UV(39)+JVS(289)*UV(41)+JVS(345)*UV(43)+JVS(423)*UV(46)
  JTUV(19) = JVS(71)*UV(19)+JVS(201)*UV(37)+JVS(258)*UV(40)+JVS(290)*UV(41)+JVS(346)*UV(43)+JVS(424)*UV(46)
  JTUV(20) = JVS(75)*UV(20)+JVS(221)*UV(38)+JVS(291)*UV(41)+JVS(321)*UV(42)+JVS(347)*UV(43)
  JTUV(21) = JVS(6)*UV(3)+JVS(80)*UV(21)+JVS(202)*UV(37)+JVS(292)*UV(41)+JVS(348)*UV(43)+JVS(377)*UV(44)+JVS(400)*UV(45)&
               &+JVS(425)*UV(46)
  JTUV(22) = JVS(84)*UV(22)+JVS(222)*UV(38)+JVS(259)*UV(40)+JVS(293)*UV(41)+JVS(349)*UV(43)
  JTUV(23) = JVS(20)*UV(7)+JVS(41)*UV(13)+JVS(50)*UV(14)+JVS(90)*UV(23)+JVS(107)*UV(27)+JVS(188)*UV(36)+JVS(294)*UV(41)&
               &+JVS(350)*UV(43)
  JTUV(24) = JVS(94)*UV(24)+JVS(203)*UV(37)+JVS(223)*UV(38)+JVS(241)*UV(39)+JVS(295)*UV(41)+JVS(322)*UV(42)+JVS(351)&
               &*UV(43)+JVS(426)*UV(46)
  JTUV(25) = JVS(98)*UV(25)+JVS(165)*UV(34)+JVS(176)*UV(35)+JVS(224)*UV(38)+JVS(296)*UV(41)+JVS(323)*UV(42)+JVS(352)&
               &*UV(43)+JVS(402)*UV(45)
  JTUV(26) = JVS(55)*UV(15)+JVS(102)*UV(26)+JVS(137)*UV(31)+JVS(444)*UV(47)
  JTUV(27) = JVS(21)*UV(7)+JVS(42)*UV(13)+JVS(51)*UV(14)+JVS(91)*UV(23)+JVS(108)*UV(27)+JVS(189)*UV(36)+JVS(298)*UV(41)&
               &+JVS(354)*UV(43)
  JTUV(28) = JVS(114)*UV(28)+JVS(166)*UV(34)+JVS(177)*UV(35)+JVS(299)*UV(41)+JVS(355)*UV(43)+JVS(404)*UV(45)
  JTUV(29) = JVS(120)*UV(29)+JVS(204)*UV(37)+JVS(225)*UV(38)+JVS(300)*UV(41)+JVS(356)*UV(43)+JVS(427)*UV(46)
  JTUV(30) = JVS(37)*UV(12)+JVS(56)*UV(15)+JVS(85)*UV(22)+JVS(128)*UV(30)+JVS(226)*UV(38)+JVS(263)*UV(40)+JVS(301)&
               &*UV(41)+JVS(357)*UV(43)+JVS(405)*UV(45)
  JTUV(31) = JVS(3)*UV(2)+JVS(103)*UV(26)+JVS(129)*UV(30)+JVS(138)*UV(31)+JVS(227)*UV(38)+JVS(264)*UV(40)+JVS(302)&
               &*UV(41)+JVS(358)*UV(43)+JVS(406)*UV(45)+JVS(445)*UV(47)
  JTUV(32) = JVS(43)*UV(13)+JVS(148)*UV(32)+JVS(359)*UV(43)+JVS(378)*UV(44)+JVS(428)*UV(46)
  JTUV(33) = JVS(44)*UV(13)+JVS(59)*UV(16)+JVS(149)*UV(32)+JVS(159)*UV(33)+JVS(190)*UV(36)+JVS(205)*UV(37)+JVS(242)&
               &*UV(39)+JVS(429)*UV(46)+JVS(446)*UV(47)
  JTUV(34) = JVS(150)*UV(32)+JVS(167)*UV(34)+JVS(304)*UV(41)+JVS(361)*UV(43)+JVS(380)*UV(44)+JVS(409)*UV(45)
  JTUV(35) = JVS(33)*UV(11)+JVS(99)*UV(25)+JVS(115)*UV(28)+JVS(168)*UV(34)+JVS(178)*UV(35)+JVS(228)*UV(38)+JVS(265)&
               &*UV(40)+JVS(305)*UV(41)+JVS(324)*UV(42)+JVS(362)*UV(43)+JVS(410)*UV(45)+JVS(431)*UV(46)
  JTUV(36) = JVS(22)*UV(7)+JVS(45)*UV(13)+JVS(60)*UV(16)+JVS(109)*UV(27)+JVS(151)*UV(32)+JVS(160)*UV(33)+JVS(191)*UV(36)&
               &+JVS(206)*UV(37)+JVS(243)*UV(39)+JVS(363)*UV(43)+JVS(411)*UV(45)+JVS(432)*UV(46)+JVS(447)*UV(47)
  JTUV(37) = JVS(72)*UV(19)+JVS(86)*UV(22)+JVS(121)*UV(29)+JVS(130)*UV(30)+JVS(161)*UV(33)+JVS(192)*UV(36)+JVS(207)&
               &*UV(37)+JVS(229)*UV(38)+JVS(244)*UV(39)+JVS(267)*UV(40)+JVS(364)*UV(43)+JVS(412)*UV(45)+JVS(433)*UV(46)&
               &+JVS(448)*UV(47)
  JTUV(38) = JVS(4)*UV(2)+JVS(16)*UV(6)+JVS(30)*UV(10)+JVS(64)*UV(17)+JVS(76)*UV(20)+JVS(87)*UV(22)+JVS(95)*UV(24)&
               &+JVS(100)*UV(25)+JVS(104)*UV(26)+JVS(122)*UV(29)+JVS(131)*UV(30)+JVS(139)*UV(31)+JVS(179)*UV(35)+JVS(193)&
               &*UV(36)+JVS(208)*UV(37)+JVS(230)*UV(38)+JVS(245)*UV(39)+JVS(268)*UV(40)+JVS(308)*UV(41)+JVS(325)*UV(42)&
               &+JVS(365)*UV(43)+JVS(384)*UV(44)+JVS(413)*UV(45)+JVS(434)*UV(46)+JVS(449)*UV(47)
  JTUV(39) = JVS(7)*UV(3)+JVS(68)*UV(18)+JVS(81)*UV(21)+JVS(96)*UV(24)+JVS(123)*UV(29)+JVS(194)*UV(36)+JVS(209)*UV(37)&
               &+JVS(231)*UV(38)+JVS(246)*UV(39)+JVS(269)*UV(40)+JVS(309)*UV(41)+JVS(326)*UV(42)+JVS(366)*UV(43)+JVS(385)&
               &*UV(44)+JVS(414)*UV(45)+JVS(435)*UV(46)+JVS(450)*UV(47)
  JTUV(40) = JVS(73)*UV(19)+JVS(88)*UV(22)+JVS(124)*UV(29)+JVS(132)*UV(30)+JVS(140)*UV(31)+JVS(170)*UV(34)+JVS(180)&
               &*UV(35)+JVS(210)*UV(37)+JVS(232)*UV(38)+JVS(247)*UV(39)+JVS(270)*UV(40)+JVS(310)*UV(41)+JVS(327)*UV(42)&
               &+JVS(367)*UV(43)+JVS(386)*UV(44)+JVS(415)*UV(45)+JVS(436)*UV(46)+JVS(451)*UV(47)
  JTUV(41) = JVS(27)*UV(9)+JVS(92)*UV(23)+JVS(116)*UV(28)+JVS(311)*UV(41)+JVS(368)*UV(43)+JVS(387)*UV(44)
  JTUV(42) = JVS(17)*UV(6)+JVS(77)*UV(20)+JVS(153)*UV(32)+JVS(172)*UV(34)+JVS(182)*UV(35)+JVS(196)*UV(36)+JVS(212)&
               &*UV(37)+JVS(234)*UV(38)+JVS(249)*UV(39)+JVS(272)*UV(40)+JVS(329)*UV(42)+JVS(369)*UV(43)+JVS(417)*UV(45)&
               &+JVS(438)*UV(46)
  JTUV(43) = JVS(12)*UV(4)+JVS(14)*UV(5)+JVS(24)*UV(8)+JVS(31)*UV(10)+JVS(34)*UV(11)+JVS(38)*UV(12)+JVS(46)*UV(13)&
               &+JVS(52)*UV(14)+JVS(57)*UV(15)+JVS(61)*UV(16)+JVS(65)*UV(17)+JVS(69)*UV(18)+JVS(74)*UV(19)+JVS(78)*UV(20)&
               &+JVS(82)*UV(21)+JVS(89)*UV(22)+JVS(97)*UV(24)+JVS(101)*UV(25)+JVS(111)*UV(27)+JVS(117)*UV(28)+JVS(125)&
               &*UV(29)+JVS(133)*UV(30)+JVS(141)*UV(31)+JVS(154)*UV(32)+JVS(162)*UV(33)+JVS(173)*UV(34)+JVS(183)*UV(35)&
               &+JVS(213)*UV(37)+JVS(235)*UV(38)+JVS(250)*UV(39)+JVS(273)*UV(40)+JVS(313)*UV(41)+JVS(330)*UV(42)+JVS(370)&
               &*UV(43)+JVS(418)*UV(45)+JVS(439)*UV(46)+JVS(454)*UV(47)
  JTUV(44) = JVS(8)*UV(3)+JVS(28)*UV(9)+JVS(83)*UV(21)+JVS(118)*UV(28)+JVS(155)*UV(32)+JVS(174)*UV(34)+JVS(236)*UV(38)&
               &+JVS(251)*UV(39)+JVS(274)*UV(40)+JVS(314)*UV(41)+JVS(331)*UV(42)+JVS(371)*UV(43)+JVS(390)*UV(44)+JVS(419)&
               &*UV(45)+JVS(440)*UV(46)+JVS(455)*UV(47)
  JTUV(45) = JVS(9)*UV(3)+JVS(25)*UV(8)+JVS(66)*UV(17)+JVS(70)*UV(18)+JVS(105)*UV(26)+JVS(119)*UV(28)+JVS(134)*UV(30)&
               &+JVS(142)*UV(31)+JVS(175)*UV(34)+JVS(185)*UV(35)+JVS(237)*UV(38)+JVS(252)*UV(39)+JVS(275)*UV(40)+JVS(315)&
               &*UV(41)+JVS(332)*UV(42)+JVS(372)*UV(43)+JVS(391)*UV(44)+JVS(420)*UV(45)+JVS(441)*UV(46)+JVS(456)*UV(47)
  JTUV(46) = JVS(10)*UV(3)+JVS(47)*UV(13)+JVS(62)*UV(16)+JVS(79)*UV(20)+JVS(156)*UV(32)+JVS(186)*UV(35)+JVS(198)*UV(36)&
               &+JVS(316)*UV(41)+JVS(333)*UV(42)+JVS(373)*UV(43)+JVS(392)*UV(44)+JVS(421)*UV(45)+JVS(442)*UV(46)
  JTUV(47) = JVS(48)*UV(13)+JVS(93)*UV(23)+JVS(106)*UV(26)+JVS(143)*UV(31)+JVS(163)*UV(33)+JVS(199)*UV(36)+JVS(217)&
               &*UV(37)+JVS(239)*UV(38)+JVS(254)*UV(39)+JVS(277)*UV(40)+JVS(334)*UV(42)+JVS(374)*UV(43)+JVS(393)*UV(44)&
               &+JVS(422)*UV(45)+JVS(443)*UV(46)+JVS(458)*UV(47)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE messy_mecca_kpp_Jacobian

