! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Function of Chemical Model File
! 
! Generated by KPP-2.2.3_rs3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : messy_mecca_kpp_Function.f90
! Time                 : Mon Oct  5 12:57:27 2020
! Working directory    : /home/sander/git-repository/caaba-mecca/caaba/mecca
! Equation file        : messy_mecca_kpp.kpp
! Output root filename : messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE messy_mecca_kpp_Function

  USE messy_mecca_kpp_Parameters
  IMPLICIT NONE

! A - Rate for each equation
  REAL(kind=dp) :: A(NREACT)

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Fun - time derivatives of variables - Agregate form
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      Vdot      - Time derivative of variable species concentrations
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Fun ( V, F, RCT, Vdot )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! Vdot - Time derivative of variable species concentrations
  REAL(kind=dp) :: Vdot(NVAR)


! Computation of equation rates
  A(1) = RCT(1)*V(23)*F(1)
  A(2) = RCT(2)*V(36)*F(1)
  A(3) = RCT(3)*V(13)*F(1)
  A(4) = RCT(4)*V(43)*V(47)
  A(5) = RCT(5)*V(16)*V(43)
  A(6) = RCT(6)*V(45)*V(47)
  A(7) = RCT(7)*V(43)*V(45)
  A(8) = RCT(8)*V(45)*V(45)
  A(9) = RCT(9)*V(23)*V(41)
  A(10) = 1.8e-12*V(8)*V(43)
  A(11) = RCT(11)*V(41)*V(41)
  A(12) = V(9)
  A(13) = RCT(13)*V(23)*F(2)
  A(14) = RCT(14)*V(40)*V(47)
  A(15) = RCT(15)*V(38)*V(47)
  A(16) = RCT(16)*V(40)*V(42)
  A(17) = RCT(17)*V(38)*V(42)
  A(18) = RCT(18)*V(6)
  A(19) = RCT(19)*V(40)*V(43)
  A(20) = RCT(20)*V(40)*V(45)
  A(21) = RCT(21)*V(38)*V(43)
  A(22) = RCT(22)*V(38)*V(43)
  A(23) = RCT(23)*V(38)*V(45)
  A(24) = 3.5e-12*V(42)*V(45)
  A(25) = RCT(25)*V(22)*V(43)
  A(26) = RCT(26)*V(20)*V(43)
  A(27) = RCT(27)*V(17)
  A(28) = RCT(28)*V(17)*V(43)
  A(29) = RCT(29)*V(4)*V(43)
  A(30) = RCT(30)*V(31)*V(47)
  A(31) = RCT(31)*V(31)*V(45)
  A(32) = RCT(32)*V(31)*V(45)
  A(33) = RCT(33)*V(31)*V(40)
  A(34) = RCT(34)*V(31)*V(40)
  A(35) = RCT(35)*V(31)*V(38)
  A(36) = RCT(36)*V(31)*V(38)
  A(37) = 1.2e-14*V(26)*V(47)
  A(38) = 1300*V(26)
  A(39) = RCT(39)*V(30)*V(43)
  A(40) = RCT(40)*V(15)*V(30)
  A(41) = RCT(41)*V(30)*V(38)
  A(42) = 1.66e-12*V(15)*V(43)
  A(43) = RCT(43)*V(12)*V(43)
  A(44) = RCT(44)*V(30)*F(1)
  A(45) = RCT(45)*V(10)
  A(46) = RCT(46)*V(10)*V(43)
  A(47) = RCT(47)*V(5)*V(43)
  A(48) = RCT(48)*V(21)*V(43)
  A(49) = RCT(49)*V(39)*V(45)
  A(50) = RCT(50)*V(39)*V(45)
  A(51) = RCT(51)*V(39)*V(40)
  A(52) = RCT(52)*V(39)*V(40)
  A(53) = 1.2e-12*V(39)*V(42)
  A(54) = RCT(54)*V(39)
  A(55) = RCT(55)*V(39)
  A(56) = RCT(56)*V(18)*V(43)
  A(57) = RCT(57)*V(43)*V(46)
  A(58) = RCT(58)*V(42)*V(46)
  A(59) = RCT(59)*V(32)*V(43)
  A(60) = RCT(60)*V(34)*V(43)
  A(61) = RCT(61)*V(38)*V(39)
  A(62) = RCT(62)*V(24)
  A(63) = 3e-14*V(24)*V(43)
  A(64) = RCT(64)*V(29)*V(43)
  A(65) = RCT(65)*V(37)
  A(66) = RCT(66)*V(37)*V(38)
  A(67) = RCT(67)*V(37)*V(38)
  A(68) = RCT(68)*V(37)*V(40)
  A(69) = RCT(69)*V(37)*V(40)
  A(70) = RCT(70)*V(39)*V(47)
  A(71) = RCT(71)*V(19)*V(43)
  A(72) = RCT(72)*V(45)*V(46)
  A(73) = RCT(73)*V(35)
  A(74) = RCT(74)*V(35)*V(45)
  A(75) = RCT(75)*V(35)*V(40)
  A(76) = 1.2e-12*V(35)*V(42)
  A(77) = RCT(77)*V(35)
  A(78) = RCT(78)*V(35)
  A(79) = RCT(79)*V(28)*V(43)
  A(80) = RCT(80)*V(28)*V(43)
  A(81) = RCT(81)*V(11)*V(43)
  A(82) = 1.4e-10*V(39)*V(43)
  A(83) = RCT(83)*V(44)
  A(84) = RCT(84)*V(41)*V(44)
  A(85) = 5.2e-12*V(9)*V(44)
  A(86) = 6e-14*V(40)*V(44)
  A(87) = RCT(87)*V(38)*V(44)
  A(88) = 3.6e-14*V(32)*V(44)
  A(89) = 1e-10*V(34)*V(44)
  A(90) = 1.7e-12*V(44)*V(46)
  A(91) = 5e-12*V(21)*V(44)
  A(92) = 5e-12*V(39)*V(44)
  A(93) = 5e-12*V(44)*V(45)
  A(94) = 1e-12*V(44)*V(47)
  A(95) = 6e-11*V(44)*V(44)
  A(96) = RCT(96)*V(35)*V(38)
  A(97) = RCT(97)*V(25)
  A(98) = RCT(98)*V(25)*V(43)
  A(99) = RCT(99)*V(33)*F(1)
  A(100) = RCT(100)*V(33)*V(47)
  A(101) = 1.3e-10*V(33)*V(36)
  A(102) = 2.53e-14*V(37)*V(47)
  A(103) = 2.5e-11*V(36)*V(37)
  A(104) = 4.3e-11*V(36)*V(39)
  A(105) = RCT(105)*V(36)*V(46)
  A(106) = RCT(106)*V(1)
  A(107) = RCT(107)*V(27)*V(43)
  A(108) = RCT(108)*V(23)*V(27)
  A(109) = RCT(109)*V(23)*V(27)
  A(110) = RCT(110)*V(23)*V(27)
  A(111) = RCT(111)*V(27)*V(36)
  A(112) = RCT(112)*V(14)*F(1)
  A(113) = RCT(113)*V(14)*F(1)
  A(114) = 7e-15*V(7)*F(1)
  A(115) = RCT(115)*F(1)
  A(116) = RCT(116)*V(47)
  A(117) = RCT(117)*V(47)
  A(118) = RCT(118)*V(8)
  A(119) = RCT(119)*V(38)
  A(120) = RCT(120)*V(42)
  A(121) = RCT(121)*V(42)
  A(122) = RCT(122)*V(6)
  A(123) = RCT(123)*V(22)
  A(124) = RCT(124)*V(20)
  A(125) = RCT(125)*V(17)
  A(126) = RCT(126)*V(18)
  A(127) = RCT(127)*V(46)
  A(128) = RCT(128)*V(46)
  A(129) = RCT(129)*V(19)
  A(130) = RCT(130)*V(29)
  A(131) = RCT(131)*V(24)
  A(132) = RCT(132)*V(28)
  A(133) = RCT(133)*V(39)
  A(134) = RCT(134)*V(34)
  A(135) = RCT(135)*V(25)

! Aggregate function
  Vdot(1) = -A(106)
  Vdot(2) = A(35)
  Vdot(3) = 2*A(90)+2*A(91)+2*A(92)+A(93)
  Vdot(4) = -A(29)
  Vdot(5) = -A(47)
  Vdot(6) = A(17)-A(18)-A(122)
  Vdot(7) = A(109)+A(111)+A(112)-A(114)
  Vdot(8) = A(8)-A(10)-A(118)
  Vdot(9) = A(11)-A(12)-A(85)
  Vdot(10) = A(22)-A(45)-A(46)
  Vdot(11) = 0.5*A(78)-A(81)
  Vdot(12) = A(40)-A(43)
  Vdot(13) = -A(3)+A(5)+A(59)+0.956*A(100)+A(101)+0.3*A(105)+A(109)+A(111)+A(128)
  Vdot(14) = A(107)+A(110)-A(112)-A(113)
  Vdot(15) = A(38)-A(40)-A(42)+A(43)
  Vdot(16) = -A(5)+0.17*A(101)+A(127)
  Vdot(17) = A(23)-A(27)-A(28)-A(125)
  Vdot(18) = A(49)-A(56)-A(126)
  Vdot(19) = A(68)-A(71)-A(129)
  Vdot(20) = A(21)-A(26)+A(58)-A(124)
  Vdot(21) = -A(48)+0.5*A(55)-A(91)
  Vdot(22) = A(19)-A(25)+A(41)+A(67)-A(123)
  Vdot(23) = -A(1)-A(9)-A(13)-A(108)-A(109)-A(110)+A(116)
  Vdot(24) = A(61)-A(62)-A(63)-A(131)
  Vdot(25) = A(96)-A(97)-A(98)-A(135)
  Vdot(26) = A(30)+A(31)+A(36)-A(37)-A(38)
  Vdot(27) = -A(107)-A(109)-A(110)-A(111)
  Vdot(28) = 0.5*A(74)-A(79)-A(80)+A(84)+A(85)-A(132)
  Vdot(29) = A(52)-A(64)+A(66)-A(130)
  Vdot(30) = A(32)-A(39)-A(40)-A(41)+A(42)-A(44)+A(69)
  Vdot(31) = A(29)-A(30)-A(31)-A(32)-A(33)-A(34)-A(35)-A(36)+A(37)
  Vdot(32) = A(57)+A(58)-A(59)+A(83)-A(88)+0.17*A(101)+0.7*A(105)+0.63*A(106)+A(113)+A(127)+A(128)+A(134)
  Vdot(33) = A(47)-A(99)-A(100)-A(101)+0.75*A(103)
  Vdot(34) = -A(60)+0.5*A(74)+A(75)+A(76)+A(77)+0.5*A(78)+A(80)+A(81)+A(89)+A(98)+A(132)-A(134)+0.333*A(135)
  Vdot(35) = A(72)-A(73)-A(74)-A(75)-A(76)-A(77)-A(78)+A(79)-A(96)+A(97)+0.667*A(135)
  Vdot(36) = A(1)-A(2)+A(13)-A(101)-A(103)-A(104)-A(105)+A(108)-A(111)+A(112)+2*A(115)+A(117)+A(119)+A(120)
  Vdot(37) = 0.15*A(48)+A(51)+A(53)+A(54)-A(65)-A(66)-A(67)-A(68)-A(69)+A(70)+A(82)+0.044*A(100)-A(102)-A(103)+A(104)&
               &+A(126)+A(129)+A(130)+0.333*A(131)
  Vdot(38) = A(14)-A(15)+2*A(16)-A(17)+A(18)+A(20)-A(21)-A(22)-A(23)+A(24)+A(25)+A(27)+A(28)-A(35)-A(36)-A(41)+A(45)&
               &+A(51)+A(53)-A(61)+A(62)+A(64)-A(66)-A(67)+A(75)+A(76)+A(86)-A(87)-A(96)+A(97)-A(119)+A(120)+A(122)+A(124)&
               &+0.667*A(125)+A(130)+0.667*A(131)+0.667*A(135)
  Vdot(39) = -A(49)-A(50)-A(51)-A(52)-A(53)-A(54)-A(55)+0.6*A(56)-A(61)+A(62)-A(70)-A(82)-A(92)+A(99)+A(102)-A(104)&
               &+0.667*A(131)-A(133)
  Vdot(40) = -A(14)-A(16)-A(19)-A(20)-A(33)-A(34)+A(36)+A(39)+A(40)+A(41)+A(44)-A(51)-A(52)-A(68)-A(69)+A(71)-A(75)&
               &-A(86)+A(113)+A(114)+A(119)+A(121)+A(123)+A(129)
  Vdot(41) = A(5)+A(7)-A(9)+A(10)-2*A(11)+2*A(12)+A(25)+A(26)+A(28)+A(29)+A(32)+A(34)+A(35)+A(39)+A(42)+A(43)+A(46)&
               &+A(47)+A(48)+A(50)+A(56)+A(57)+A(60)+A(63)+A(64)+A(71)+0.3*A(74)+A(79)+A(80)+A(81)-A(84)+A(85)+A(98)+0.47&
               &*A(106)+A(107)
  Vdot(42) = A(15)-A(16)-A(17)+A(18)-A(24)+A(26)+A(46)-A(53)-A(58)+A(63)-A(76)+A(87)+A(98)-A(120)-A(121)+A(122)+0.333&
               &*A(125)+0.333*A(131)+0.333*A(135)
  Vdot(43) = -A(4)-A(5)+A(6)-A(7)+2*A(9)-A(10)-A(19)+A(20)-A(21)-A(22)+A(24)-A(25)-A(26)-A(28)-A(29)+A(31)+A(33)-A(39)&
               &-A(42)-A(43)+A(45)-A(46)-A(47)-A(48)-0.6*A(56)-A(57)-A(59)-A(60)-A(63)-A(64)-A(71)+0.2*A(74)-A(79)-A(81)&
               &-A(82)+A(83)-A(98)+0.25*A(103)+0.7*A(105)+0.16*A(106)-A(107)+A(110)+2*A(118)+A(123)+A(124)+0.333*A(125)&
               &+A(126)+A(132)+A(133)+A(134)
  Vdot(44) = -A(83)-A(84)-A(85)-A(86)-A(87)-A(88)-A(89)-A(90)-A(91)-A(92)-A(93)-A(94)-2*A(95)+0.37*A(106)
  Vdot(45) = A(3)+A(4)-A(6)-A(7)-2*A(8)+A(10)-A(20)-A(23)-A(24)+A(27)-A(31)-A(32)+A(33)+A(44)+0.85*A(48)-A(49)-A(50)&
               &+A(57)+A(58)+A(60)+A(65)-A(72)+A(73)-0.8*A(74)+A(75)+A(76)+A(77)+A(81)+A(82)+A(83)-A(93)+A(105)+0.16*A(106)&
               &+0.667*A(125)+A(128)+A(132)+A(134)+0.333*A(135)
  Vdot(46) = 0.85*A(48)+A(50)+0.5*A(55)+0.4*A(56)-A(57)-A(58)+A(63)+A(64)+A(65)+A(67)+A(69)+A(71)-A(72)+A(73)+A(86)&
               &+A(87)+A(88)-A(90)+A(94)+2*A(95)+0.956*A(100)+0.83*A(101)+0.25*A(103)-A(105)-A(127)-A(128)+A(133)
  Vdot(47) = A(2)-A(4)-A(6)-A(14)-A(15)-A(30)-A(37)-A(70)-A(94)-A(100)-A(102)-A(116)-A(117)
      
END SUBROUTINE Fun

! End of Fun function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Fun_SPLIT - time derivatives of variables - Split form
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      P_VAR     - Production term
!      D_VAR     - Destruction term
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Fun_SPLIT ( V, F, RCT, P_VAR, D_VAR )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! P_VAR - Production term
  REAL(kind=dp) :: P_VAR(NVAR)
! D_VAR - Destruction term
  REAL(kind=dp) :: D_VAR(NVAR)


! Computation of equation rates
  A(1) = RCT(1)*V(23)*F(1)
  A(2) = RCT(2)*V(36)*F(1)
  A(3) = RCT(3)*V(13)*F(1)
  A(4) = RCT(4)*V(43)*V(47)
  A(5) = RCT(5)*V(16)*V(43)
  A(6) = RCT(6)*V(45)*V(47)
  A(7) = RCT(7)*V(43)*V(45)
  A(8) = RCT(8)*V(45)*V(45)
  A(9) = RCT(9)*V(23)*V(41)
  A(10) = 1.8e-12*V(8)*V(43)
  A(11) = RCT(11)*V(41)*V(41)
  A(12) = V(9)
  A(13) = RCT(13)*V(23)*F(2)
  A(14) = RCT(14)*V(40)*V(47)
  A(15) = RCT(15)*V(38)*V(47)
  A(16) = RCT(16)*V(40)*V(42)
  A(17) = RCT(17)*V(38)*V(42)
  A(18) = RCT(18)*V(6)
  A(19) = RCT(19)*V(40)*V(43)
  A(20) = RCT(20)*V(40)*V(45)
  A(21) = RCT(21)*V(38)*V(43)
  A(22) = RCT(22)*V(38)*V(43)
  A(23) = RCT(23)*V(38)*V(45)
  A(24) = 3.5e-12*V(42)*V(45)
  A(25) = RCT(25)*V(22)*V(43)
  A(26) = RCT(26)*V(20)*V(43)
  A(27) = RCT(27)*V(17)
  A(28) = RCT(28)*V(17)*V(43)
  A(29) = RCT(29)*V(4)*V(43)
  A(30) = RCT(30)*V(31)*V(47)
  A(31) = RCT(31)*V(31)*V(45)
  A(32) = RCT(32)*V(31)*V(45)
  A(33) = RCT(33)*V(31)*V(40)
  A(34) = RCT(34)*V(31)*V(40)
  A(35) = RCT(35)*V(31)*V(38)
  A(36) = RCT(36)*V(31)*V(38)
  A(37) = 1.2e-14*V(26)*V(47)
  A(38) = 1300*V(26)
  A(39) = RCT(39)*V(30)*V(43)
  A(40) = RCT(40)*V(15)*V(30)
  A(41) = RCT(41)*V(30)*V(38)
  A(42) = 1.66e-12*V(15)*V(43)
  A(43) = RCT(43)*V(12)*V(43)
  A(44) = RCT(44)*V(30)*F(1)
  A(45) = RCT(45)*V(10)
  A(46) = RCT(46)*V(10)*V(43)
  A(47) = RCT(47)*V(5)*V(43)
  A(48) = RCT(48)*V(21)*V(43)
  A(49) = RCT(49)*V(39)*V(45)
  A(50) = RCT(50)*V(39)*V(45)
  A(51) = RCT(51)*V(39)*V(40)
  A(52) = RCT(52)*V(39)*V(40)
  A(53) = 1.2e-12*V(39)*V(42)
  A(54) = RCT(54)*V(39)
  A(55) = RCT(55)*V(39)
  A(56) = RCT(56)*V(18)*V(43)
  A(57) = RCT(57)*V(43)*V(46)
  A(58) = RCT(58)*V(42)*V(46)
  A(59) = RCT(59)*V(32)*V(43)
  A(60) = RCT(60)*V(34)*V(43)
  A(61) = RCT(61)*V(38)*V(39)
  A(62) = RCT(62)*V(24)
  A(63) = 3e-14*V(24)*V(43)
  A(64) = RCT(64)*V(29)*V(43)
  A(65) = RCT(65)*V(37)
  A(66) = RCT(66)*V(37)*V(38)
  A(67) = RCT(67)*V(37)*V(38)
  A(68) = RCT(68)*V(37)*V(40)
  A(69) = RCT(69)*V(37)*V(40)
  A(70) = RCT(70)*V(39)*V(47)
  A(71) = RCT(71)*V(19)*V(43)
  A(72) = RCT(72)*V(45)*V(46)
  A(73) = RCT(73)*V(35)
  A(74) = RCT(74)*V(35)*V(45)
  A(75) = RCT(75)*V(35)*V(40)
  A(76) = 1.2e-12*V(35)*V(42)
  A(77) = RCT(77)*V(35)
  A(78) = RCT(78)*V(35)
  A(79) = RCT(79)*V(28)*V(43)
  A(80) = RCT(80)*V(28)*V(43)
  A(81) = RCT(81)*V(11)*V(43)
  A(82) = 1.4e-10*V(39)*V(43)
  A(83) = RCT(83)*V(44)
  A(84) = RCT(84)*V(41)*V(44)
  A(85) = 5.2e-12*V(9)*V(44)
  A(86) = 6e-14*V(40)*V(44)
  A(87) = RCT(87)*V(38)*V(44)
  A(88) = 3.6e-14*V(32)*V(44)
  A(89) = 1e-10*V(34)*V(44)
  A(90) = 1.7e-12*V(44)*V(46)
  A(91) = 5e-12*V(21)*V(44)
  A(92) = 5e-12*V(39)*V(44)
  A(93) = 5e-12*V(44)*V(45)
  A(94) = 1e-12*V(44)*V(47)
  A(95) = 6e-11*V(44)*V(44)
  A(96) = RCT(96)*V(35)*V(38)
  A(97) = RCT(97)*V(25)
  A(98) = RCT(98)*V(25)*V(43)
  A(99) = RCT(99)*V(33)*F(1)
  A(100) = RCT(100)*V(33)*V(47)
  A(101) = 1.3e-10*V(33)*V(36)
  A(102) = 2.53e-14*V(37)*V(47)
  A(103) = 2.5e-11*V(36)*V(37)
  A(104) = 4.3e-11*V(36)*V(39)
  A(105) = RCT(105)*V(36)*V(46)
  A(106) = RCT(106)*V(1)
  A(107) = RCT(107)*V(27)*V(43)
  A(108) = RCT(108)*V(23)*V(27)
  A(109) = RCT(109)*V(23)*V(27)
  A(110) = RCT(110)*V(23)*V(27)
  A(111) = RCT(111)*V(27)*V(36)
  A(112) = RCT(112)*V(14)*F(1)
  A(113) = RCT(113)*V(14)*F(1)
  A(114) = 7e-15*V(7)*F(1)
  A(115) = RCT(115)*F(1)
  A(116) = RCT(116)*V(47)
  A(117) = RCT(117)*V(47)
  A(118) = RCT(118)*V(8)
  A(119) = RCT(119)*V(38)
  A(120) = RCT(120)*V(42)
  A(121) = RCT(121)*V(42)
  A(122) = RCT(122)*V(6)
  A(123) = RCT(123)*V(22)
  A(124) = RCT(124)*V(20)
  A(125) = RCT(125)*V(17)
  A(126) = RCT(126)*V(18)
  A(127) = RCT(127)*V(46)
  A(128) = RCT(128)*V(46)
  A(129) = RCT(129)*V(19)
  A(130) = RCT(130)*V(29)
  A(131) = RCT(131)*V(24)
  A(132) = RCT(132)*V(28)
  A(133) = RCT(133)*V(39)
  A(134) = RCT(134)*V(34)
  A(135) = RCT(135)*V(25)

! Production function
  P_VAR(1) = 0
  P_VAR(2) = A(35)
  P_VAR(3) = 2*A(90)+2*A(91)+2*A(92)+A(93)
  P_VAR(4) = 0
  P_VAR(5) = 0
  P_VAR(6) = A(17)
  P_VAR(7) = A(109)+A(111)+A(112)
  P_VAR(8) = A(8)
  P_VAR(9) = A(11)
  P_VAR(10) = A(22)
  P_VAR(11) = 0.5*A(78)
  P_VAR(12) = A(40)
  P_VAR(13) = A(5)+A(59)+0.956*A(100)+A(101)+0.3*A(105)+A(109)+A(111)+A(128)
  P_VAR(14) = A(107)+A(110)
  P_VAR(15) = A(38)+A(43)
  P_VAR(16) = 0.17*A(101)+A(127)
  P_VAR(17) = A(23)
  P_VAR(18) = A(49)
  P_VAR(19) = A(68)
  P_VAR(20) = A(21)+A(58)
  P_VAR(21) = 0.5*A(55)
  P_VAR(22) = A(19)+A(41)+A(67)
  P_VAR(23) = A(116)
  P_VAR(24) = A(61)
  P_VAR(25) = A(96)
  P_VAR(26) = A(30)+A(31)+A(36)
  P_VAR(27) = A(108)
  P_VAR(28) = 0.5*A(74)+A(84)+A(85)
  P_VAR(29) = A(52)+A(66)
  P_VAR(30) = A(32)+A(42)+A(69)
  P_VAR(31) = A(29)+A(37)
  P_VAR(32) = A(57)+A(58)+A(83)+0.17*A(101)+0.7*A(105)+0.63*A(106)+A(113)+A(127)+A(128)+A(134)
  P_VAR(33) = A(47)+0.75*A(103)
  P_VAR(34) = 0.5*A(74)+A(75)+A(76)+A(77)+0.5*A(78)+A(80)+A(81)+2*A(89)+A(98)+A(132)+0.333*A(135)
  P_VAR(35) = A(72)+A(79)+A(97)+0.667*A(135)
  P_VAR(36) = A(1)+A(13)+A(108)+A(112)+2*A(115)+A(117)+A(119)+A(120)
  P_VAR(37) = 0.15*A(48)+A(51)+A(53)+A(54)+A(70)+A(82)+0.044*A(100)+A(104)+A(126)+A(129)+A(130)+0.333*A(131)
  P_VAR(38) = A(14)+2*A(16)+A(18)+A(20)+A(24)+A(25)+A(27)+A(28)+A(45)+A(51)+A(53)+A(62)+A(64)+A(75)+A(76)+A(86)+A(97)&
                &+A(120)+A(122)+A(124)+0.667*A(125)+A(130)+0.667*A(131)+0.667*A(135)
  P_VAR(39) = 0.6*A(56)+A(62)+A(99)+A(102)+0.667*A(131)
  P_VAR(40) = A(36)+A(39)+A(40)+A(41)+A(44)+A(71)+A(113)+A(114)+A(119)+A(121)+A(123)+A(129)
  P_VAR(41) = A(5)+A(7)+A(10)+2*A(12)+A(25)+A(26)+A(28)+A(29)+A(32)+A(34)+A(35)+A(39)+A(42)+A(43)+A(46)+A(47)+A(48)&
                &+A(50)+A(56)+A(57)+A(60)+A(63)+A(64)+A(71)+0.3*A(74)+A(79)+A(80)+A(81)+A(85)+A(98)+0.47*A(106)+A(107)
  P_VAR(42) = A(15)+A(18)+A(26)+A(46)+A(63)+A(87)+A(98)+A(122)+0.333*A(125)+0.333*A(131)+0.333*A(135)
  P_VAR(43) = A(6)+2*A(9)+A(20)+A(24)+A(31)+A(33)+A(45)+0.4*A(56)+0.2*A(74)+A(80)+A(83)+0.25*A(103)+0.7*A(105)+0.16&
                &*A(106)+A(110)+2*A(118)+A(123)+A(124)+0.333*A(125)+A(126)+A(132)+A(133)+A(134)
  P_VAR(44) = 0.37*A(106)
  P_VAR(45) = A(3)+A(4)+A(10)+A(27)+A(33)+A(44)+0.85*A(48)+A(57)+A(58)+A(60)+A(65)+A(73)+0.2*A(74)+A(75)+A(76)+A(77)&
                &+A(81)+A(82)+A(83)+A(105)+0.16*A(106)+0.667*A(125)+A(128)+A(132)+A(134)+0.333*A(135)
  P_VAR(46) = 0.85*A(48)+A(50)+0.5*A(55)+0.4*A(56)+A(63)+A(64)+A(65)+A(67)+A(69)+A(71)+A(73)+A(86)+A(87)+A(88)+A(94)+2&
                &*A(95)+0.956*A(100)+0.83*A(101)+0.25*A(103)+A(133)
  P_VAR(47) = A(2)

! Destruction function
  D_VAR(1) = RCT(106)
  D_VAR(2) = 0
  D_VAR(3) = 0
  D_VAR(4) = RCT(29)*V(43)
  D_VAR(5) = RCT(47)*V(43)
  D_VAR(6) = RCT(18)+RCT(122)
  D_VAR(7) = 7e-15*F(1)
  D_VAR(8) = 1.8e-12*V(43)+RCT(118)
  D_VAR(9) = 1+5.2e-12*V(44)
  D_VAR(10) = RCT(45)+RCT(46)*V(43)
  D_VAR(11) = RCT(81)*V(43)
  D_VAR(12) = RCT(43)*V(43)
  D_VAR(13) = RCT(3)*F(1)
  D_VAR(14) = RCT(112)*F(1)+RCT(113)*F(1)
  D_VAR(15) = RCT(40)*V(30)+1.66e-12*V(43)
  D_VAR(16) = RCT(5)*V(43)
  D_VAR(17) = RCT(27)+RCT(28)*V(43)+RCT(125)
  D_VAR(18) = RCT(56)*V(43)+RCT(126)
  D_VAR(19) = RCT(71)*V(43)+RCT(129)
  D_VAR(20) = RCT(26)*V(43)+RCT(124)
  D_VAR(21) = RCT(48)*V(43)+5e-12*V(44)
  D_VAR(22) = RCT(25)*V(43)+RCT(123)
  D_VAR(23) = RCT(1)*F(1)+RCT(9)*V(41)+RCT(13)*F(2)+RCT(108)*V(27)+RCT(109)*V(27)+RCT(110)*V(27)
  D_VAR(24) = RCT(62)+3e-14*V(43)+RCT(131)
  D_VAR(25) = RCT(97)+RCT(98)*V(43)+RCT(135)
  D_VAR(26) = 1.2e-14*V(47)+1300
  D_VAR(27) = RCT(107)*V(43)+RCT(108)*V(23)+RCT(109)*V(23)+RCT(110)*V(23)+RCT(111)*V(36)
  D_VAR(28) = RCT(79)*V(43)+RCT(80)*V(43)+RCT(132)
  D_VAR(29) = RCT(64)*V(43)+RCT(130)
  D_VAR(30) = RCT(39)*V(43)+RCT(40)*V(15)+RCT(41)*V(38)+RCT(44)*F(1)
  D_VAR(31) = RCT(30)*V(47)+RCT(31)*V(45)+RCT(32)*V(45)+RCT(33)*V(40)+RCT(34)*V(40)+RCT(35)*V(38)+RCT(36)*V(38)
  D_VAR(32) = RCT(59)*V(43)+3.6e-14*V(44)
  D_VAR(33) = RCT(99)*F(1)+RCT(100)*V(47)+1.3e-10*V(36)
  D_VAR(34) = RCT(60)*V(43)+1e-10*V(44)+RCT(134)
  D_VAR(35) = RCT(73)+RCT(74)*V(45)+RCT(75)*V(40)+1.2e-12*V(42)+RCT(77)+RCT(78)+RCT(96)*V(38)
  D_VAR(36) = RCT(2)*F(1)+1.3e-10*V(33)+2.5e-11*V(37)+4.3e-11*V(39)+RCT(105)*V(46)+RCT(111)*V(27)
  D_VAR(37) = RCT(65)+RCT(66)*V(38)+RCT(67)*V(38)+RCT(68)*V(40)+RCT(69)*V(40)+2.53e-14*V(47)+2.5e-11*V(36)
  D_VAR(38) = RCT(15)*V(47)+RCT(17)*V(42)+RCT(21)*V(43)+RCT(22)*V(43)+RCT(23)*V(45)+RCT(35)*V(31)+RCT(36)*V(31)+RCT(41)&
                &*V(30)+RCT(61)*V(39)+RCT(66)*V(37)+RCT(67)*V(37)+RCT(87)*V(44)+RCT(96)*V(35)+RCT(119)
  D_VAR(39) = RCT(49)*V(45)+RCT(50)*V(45)+RCT(51)*V(40)+RCT(52)*V(40)+1.2e-12*V(42)+RCT(54)+RCT(55)+RCT(61)*V(38)&
                &+RCT(70)*V(47)+1.4e-10*V(43)+5e-12*V(44)+4.3e-11*V(36)+RCT(133)
  D_VAR(40) = RCT(14)*V(47)+RCT(16)*V(42)+RCT(19)*V(43)+RCT(20)*V(45)+RCT(33)*V(31)+RCT(34)*V(31)+RCT(51)*V(39)+RCT(52)&
                &*V(39)+RCT(68)*V(37)+RCT(69)*V(37)+RCT(75)*V(35)+6e-14*V(44)
  D_VAR(41) = RCT(9)*V(23)+RCT(11)*2*V(41)+RCT(84)*V(44)
  D_VAR(42) = RCT(16)*V(40)+RCT(17)*V(38)+3.5e-12*V(45)+1.2e-12*V(39)+RCT(58)*V(46)+1.2e-12*V(35)+RCT(120)+RCT(121)
  D_VAR(43) = RCT(4)*V(47)+RCT(5)*V(16)+RCT(7)*V(45)+1.8e-12*V(8)+RCT(19)*V(40)+RCT(21)*V(38)+RCT(22)*V(38)+RCT(25)&
                &*V(22)+RCT(26)*V(20)+RCT(28)*V(17)+RCT(29)*V(4)+RCT(39)*V(30)+1.66e-12*V(15)+RCT(43)*V(12)+RCT(46)*V(10)&
                &+RCT(47)*V(5)+RCT(48)*V(21)+RCT(56)*V(18)+RCT(57)*V(46)+RCT(59)*V(32)+RCT(60)*V(34)+3e-14*V(24)+RCT(64)&
                &*V(29)+RCT(71)*V(19)+RCT(79)*V(28)+RCT(80)*V(28)+RCT(81)*V(11)+1.4e-10*V(39)+RCT(98)*V(25)+RCT(107)*V(27)
  D_VAR(44) = RCT(83)+RCT(84)*V(41)+5.2e-12*V(9)+6e-14*V(40)+RCT(87)*V(38)+3.6e-14*V(32)+1e-10*V(34)+1.7e-12*V(46)+5e-12&
                &*V(21)+5e-12*V(39)+5e-12*V(45)+1e-12*V(47)+6e-11*2*V(44)
  D_VAR(45) = RCT(6)*V(47)+RCT(7)*V(43)+RCT(8)*2*V(45)+RCT(20)*V(40)+RCT(23)*V(38)+3.5e-12*V(42)+RCT(31)*V(31)+RCT(32)&
                &*V(31)+RCT(49)*V(39)+RCT(50)*V(39)+RCT(72)*V(46)+RCT(74)*V(35)+5e-12*V(44)
  D_VAR(46) = RCT(57)*V(43)+RCT(58)*V(42)+RCT(72)*V(45)+1.7e-12*V(44)+RCT(105)*V(36)+RCT(127)+RCT(128)
  D_VAR(47) = RCT(4)*V(43)+RCT(6)*V(45)+RCT(14)*V(40)+RCT(15)*V(38)+RCT(30)*V(31)+1.2e-14*V(26)+RCT(70)*V(39)+1e-12&
                &*V(44)+RCT(100)*V(33)+2.53e-14*V(37)+RCT(116)+RCT(117)
      
END SUBROUTINE Fun_SPLIT

! End of Fun_SPLIT function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! CalcStoichNum - calculate stoichiometric numbers
!   Arguments :
!      StoichNum - Stoichiometric numbers
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE CalcStoichNum ( StoichNum )

! StoichNum - Stoichiometric numbers
  REAL(kind=dp) :: StoichNum(NVAR,NREACT)

  StoichNum(:,:) = 0.
  StoichNum(1,106) = -1
  StoichNum(2,35) = 1
  StoichNum(3,90) = 2
  StoichNum(3,91) = 2
  StoichNum(3,92) = 2
  StoichNum(3,93) = 1
  StoichNum(4,29) = -1
  StoichNum(5,47) = -1
  StoichNum(6,17) = 1
  StoichNum(6,18) = -1
  StoichNum(6,122) = -1
  StoichNum(7,109) = 1
  StoichNum(7,111) = 1
  StoichNum(7,112) = 1
  StoichNum(7,114) = -1
  StoichNum(8,8) = 1
  StoichNum(8,10) = -1
  StoichNum(8,118) = -1
  StoichNum(9,11) = 1
  StoichNum(9,12) = -1
  StoichNum(9,85) = -1
  StoichNum(10,22) = 1
  StoichNum(10,45) = -1
  StoichNum(10,46) = -1
  StoichNum(11,78) = 0.5
  StoichNum(11,81) = -1
  StoichNum(12,40) = 1
  StoichNum(12,43) = -1
  StoichNum(13,3) = -1
  StoichNum(13,5) = 1
  StoichNum(13,59) = 1
  StoichNum(13,100) = 0.956
  StoichNum(13,101) = 1
  StoichNum(13,105) = 0.3
  StoichNum(13,109) = 1
  StoichNum(13,111) = 1
  StoichNum(13,128) = 1
  StoichNum(14,107) = 1
  StoichNum(14,110) = 1
  StoichNum(14,112) = -1
  StoichNum(14,113) = -1
  StoichNum(15,38) = 1
  StoichNum(15,40) = -1
  StoichNum(15,42) = -1
  StoichNum(15,43) = 1
  StoichNum(16,5) = -1
  StoichNum(16,101) = 0.17
  StoichNum(16,127) = 1
  StoichNum(17,23) = 1
  StoichNum(17,27) = -1
  StoichNum(17,28) = -1
  StoichNum(17,125) = -1
  StoichNum(18,49) = 1
  StoichNum(18,56) = -1
  StoichNum(18,126) = -1
  StoichNum(19,68) = 1
  StoichNum(19,71) = -1
  StoichNum(19,129) = -1
  StoichNum(20,21) = 1
  StoichNum(20,26) = -1
  StoichNum(20,58) = 1
  StoichNum(20,124) = -1
  StoichNum(21,48) = -1
  StoichNum(21,55) = 0.5
  StoichNum(21,91) = -1
  StoichNum(22,19) = 1
  StoichNum(22,25) = -1
  StoichNum(22,41) = 1
  StoichNum(22,67) = 1
  StoichNum(22,123) = -1
  StoichNum(23,1) = -1
  StoichNum(23,9) = -1
  StoichNum(23,13) = -1
  StoichNum(23,108) = -1
  StoichNum(23,109) = -1
  StoichNum(23,110) = -1
  StoichNum(23,116) = 1
  StoichNum(24,61) = 1
  StoichNum(24,62) = -1
  StoichNum(24,63) = -1
  StoichNum(24,131) = -1
  StoichNum(25,96) = 1
  StoichNum(25,97) = -1
  StoichNum(25,98) = -1
  StoichNum(25,135) = -1
  StoichNum(26,30) = 1
  StoichNum(26,31) = 1
  StoichNum(26,36) = 1
  StoichNum(26,37) = -1
  StoichNum(26,38) = -1
  StoichNum(27,107) = -1
  StoichNum(27,109) = -1
  StoichNum(27,110) = -1
  StoichNum(27,111) = -1
  StoichNum(28,74) = 0.5
  StoichNum(28,79) = -1
  StoichNum(28,80) = -1
  StoichNum(28,84) = 1
  StoichNum(28,85) = 1
  StoichNum(28,132) = -1
  StoichNum(29,52) = 1
  StoichNum(29,64) = -1
  StoichNum(29,66) = 1
  StoichNum(29,130) = -1
  StoichNum(30,32) = 1
  StoichNum(30,39) = -1
  StoichNum(30,40) = -1
  StoichNum(30,41) = -1
  StoichNum(30,42) = 1
  StoichNum(30,44) = -1
  StoichNum(30,69) = 1
  StoichNum(31,29) = 1
  StoichNum(31,30) = -1
  StoichNum(31,31) = -1
  StoichNum(31,32) = -1
  StoichNum(31,33) = -1
  StoichNum(31,34) = -1
  StoichNum(31,35) = -1
  StoichNum(31,36) = -1
  StoichNum(31,37) = 1
  StoichNum(32,57) = 1
  StoichNum(32,58) = 1
  StoichNum(32,59) = -1
  StoichNum(32,83) = 1
  StoichNum(32,88) = -1
  StoichNum(32,101) = 0.17
  StoichNum(32,105) = 0.7
  StoichNum(32,106) = 0.63
  StoichNum(32,113) = 1
  StoichNum(32,127) = 1
  StoichNum(32,128) = 1
  StoichNum(32,134) = 1
  StoichNum(33,47) = 1
  StoichNum(33,99) = -1
  StoichNum(33,100) = -1
  StoichNum(33,101) = -1
  StoichNum(33,103) = 0.75
  StoichNum(34,60) = -1
  StoichNum(34,74) = 0.5
  StoichNum(34,75) = 1
  StoichNum(34,76) = 1
  StoichNum(34,77) = 1
  StoichNum(34,78) = 0.5
  StoichNum(34,80) = 1
  StoichNum(34,81) = 1
  StoichNum(34,89) = 1
  StoichNum(34,98) = 1
  StoichNum(34,132) = 1
  StoichNum(34,134) = -1
  StoichNum(34,135) = 0.333
  StoichNum(35,72) = 1
  StoichNum(35,73) = -1
  StoichNum(35,74) = -1
  StoichNum(35,75) = -1
  StoichNum(35,76) = -1
  StoichNum(35,77) = -1
  StoichNum(35,78) = -1
  StoichNum(35,79) = 1
  StoichNum(35,96) = -1
  StoichNum(35,97) = 1
  StoichNum(35,135) = 0.667
  StoichNum(36,1) = 1
  StoichNum(36,2) = -1
  StoichNum(36,13) = 1
  StoichNum(36,101) = -1
  StoichNum(36,103) = -1
  StoichNum(36,104) = -1
  StoichNum(36,105) = -1
  StoichNum(36,108) = 1
  StoichNum(36,111) = -1
  StoichNum(36,112) = 1
  StoichNum(36,115) = 2
  StoichNum(36,117) = 1
  StoichNum(36,119) = 1
  StoichNum(36,120) = 1
  StoichNum(37,48) = 0.15
  StoichNum(37,51) = 1
  StoichNum(37,53) = 1
  StoichNum(37,54) = 1
  StoichNum(37,65) = -1
  StoichNum(37,66) = -1
  StoichNum(37,67) = -1
  StoichNum(37,68) = -1
  StoichNum(37,69) = -1
  StoichNum(37,70) = 1
  StoichNum(37,82) = 1
  StoichNum(37,100) = 0.044
  StoichNum(37,102) = -1
  StoichNum(37,103) = -1
  StoichNum(37,104) = 1
  StoichNum(37,126) = 1
  StoichNum(37,129) = 1
  StoichNum(37,130) = 1
  StoichNum(37,131) = 0.333
  StoichNum(38,14) = 1
  StoichNum(38,15) = -1
  StoichNum(38,16) = 2
  StoichNum(38,17) = -1
  StoichNum(38,18) = 1
  StoichNum(38,20) = 1
  StoichNum(38,21) = -1
  StoichNum(38,22) = -1
  StoichNum(38,23) = -1
  StoichNum(38,24) = 1
  StoichNum(38,25) = 1
  StoichNum(38,27) = 1
  StoichNum(38,28) = 1
  StoichNum(38,35) = -1
  StoichNum(38,36) = -1
  StoichNum(38,41) = -1
  StoichNum(38,45) = 1
  StoichNum(38,51) = 1
  StoichNum(38,53) = 1
  StoichNum(38,61) = -1
  StoichNum(38,62) = 1
  StoichNum(38,64) = 1
  StoichNum(38,66) = -1
  StoichNum(38,67) = -1
  StoichNum(38,75) = 1
  StoichNum(38,76) = 1
  StoichNum(38,86) = 1
  StoichNum(38,87) = -1
  StoichNum(38,96) = -1
  StoichNum(38,97) = 1
  StoichNum(38,119) = -1
  StoichNum(38,120) = 1
  StoichNum(38,122) = 1
  StoichNum(38,124) = 1
  StoichNum(38,125) = 0.667
  StoichNum(38,130) = 1
  StoichNum(38,131) = 0.667
  StoichNum(38,135) = 0.667
  StoichNum(39,49) = -1
  StoichNum(39,50) = -1
  StoichNum(39,51) = -1
  StoichNum(39,52) = -1
  StoichNum(39,53) = -1
  StoichNum(39,54) = -1
  StoichNum(39,55) = -1
  StoichNum(39,56) = 0.6
  StoichNum(39,61) = -1
  StoichNum(39,62) = 1
  StoichNum(39,70) = -1
  StoichNum(39,82) = -1
  StoichNum(39,92) = -1
  StoichNum(39,99) = 1
  StoichNum(39,102) = 1
  StoichNum(39,104) = -1
  StoichNum(39,131) = 0.667
  StoichNum(39,133) = -1
  StoichNum(40,14) = -1
  StoichNum(40,16) = -1
  StoichNum(40,19) = -1
  StoichNum(40,20) = -1
  StoichNum(40,33) = -1
  StoichNum(40,34) = -1
  StoichNum(40,36) = 1
  StoichNum(40,39) = 1
  StoichNum(40,40) = 1
  StoichNum(40,41) = 1
  StoichNum(40,44) = 1
  StoichNum(40,51) = -1
  StoichNum(40,52) = -1
  StoichNum(40,68) = -1
  StoichNum(40,69) = -1
  StoichNum(40,71) = 1
  StoichNum(40,75) = -1
  StoichNum(40,86) = -1
  StoichNum(40,113) = 1
  StoichNum(40,114) = 1
  StoichNum(40,119) = 1
  StoichNum(40,121) = 1
  StoichNum(40,123) = 1
  StoichNum(40,129) = 1
  StoichNum(41,5) = 1
  StoichNum(41,7) = 1
  StoichNum(41,9) = -1
  StoichNum(41,10) = 1
  StoichNum(41,11) = -2
  StoichNum(41,12) = 2
  StoichNum(41,25) = 1
  StoichNum(41,26) = 1
  StoichNum(41,28) = 1
  StoichNum(41,29) = 1
  StoichNum(41,32) = 1
  StoichNum(41,34) = 1
  StoichNum(41,35) = 1
  StoichNum(41,39) = 1
  StoichNum(41,42) = 1
  StoichNum(41,43) = 1
  StoichNum(41,46) = 1
  StoichNum(41,47) = 1
  StoichNum(41,48) = 1
  StoichNum(41,50) = 1
  StoichNum(41,56) = 1
  StoichNum(41,57) = 1
  StoichNum(41,60) = 1
  StoichNum(41,63) = 1
  StoichNum(41,64) = 1
  StoichNum(41,71) = 1
  StoichNum(41,74) = 0.3
  StoichNum(41,79) = 1
  StoichNum(41,80) = 1
  StoichNum(41,81) = 1
  StoichNum(41,84) = -1
  StoichNum(41,85) = 1
  StoichNum(41,98) = 1
  StoichNum(41,106) = 0.47
  StoichNum(41,107) = 1
  StoichNum(42,15) = 1
  StoichNum(42,16) = -1
  StoichNum(42,17) = -1
  StoichNum(42,18) = 1
  StoichNum(42,24) = -1
  StoichNum(42,26) = 1
  StoichNum(42,46) = 1
  StoichNum(42,53) = -1
  StoichNum(42,58) = -1
  StoichNum(42,63) = 1
  StoichNum(42,76) = -1
  StoichNum(42,87) = 1
  StoichNum(42,98) = 1
  StoichNum(42,120) = -1
  StoichNum(42,121) = -1
  StoichNum(42,122) = 1
  StoichNum(42,125) = 0.333
  StoichNum(42,131) = 0.333
  StoichNum(42,135) = 0.333
  StoichNum(43,4) = -1
  StoichNum(43,5) = -1
  StoichNum(43,6) = 1
  StoichNum(43,7) = -1
  StoichNum(43,9) = 2
  StoichNum(43,10) = -1
  StoichNum(43,19) = -1
  StoichNum(43,20) = 1
  StoichNum(43,21) = -1
  StoichNum(43,22) = -1
  StoichNum(43,24) = 1
  StoichNum(43,25) = -1
  StoichNum(43,26) = -1
  StoichNum(43,28) = -1
  StoichNum(43,29) = -1
  StoichNum(43,31) = 1
  StoichNum(43,33) = 1
  StoichNum(43,39) = -1
  StoichNum(43,42) = -1
  StoichNum(43,43) = -1
  StoichNum(43,45) = 1
  StoichNum(43,46) = -1
  StoichNum(43,47) = -1
  StoichNum(43,48) = -1
  StoichNum(43,56) = -0.6
  StoichNum(43,57) = -1
  StoichNum(43,59) = -1
  StoichNum(43,60) = -1
  StoichNum(43,63) = -1
  StoichNum(43,64) = -1
  StoichNum(43,71) = -1
  StoichNum(43,74) = 0.2
  StoichNum(43,79) = -1
  StoichNum(43,81) = -1
  StoichNum(43,82) = -1
  StoichNum(43,83) = 1
  StoichNum(43,98) = -1
  StoichNum(43,103) = 0.25
  StoichNum(43,105) = 0.7
  StoichNum(43,106) = 0.16
  StoichNum(43,107) = -1
  StoichNum(43,110) = 1
  StoichNum(43,118) = 2
  StoichNum(43,123) = 1
  StoichNum(43,124) = 1
  StoichNum(43,125) = 0.333
  StoichNum(43,126) = 1
  StoichNum(43,132) = 1
  StoichNum(43,133) = 1
  StoichNum(43,134) = 1
  StoichNum(44,83) = -1
  StoichNum(44,84) = -1
  StoichNum(44,85) = -1
  StoichNum(44,86) = -1
  StoichNum(44,87) = -1
  StoichNum(44,88) = -1
  StoichNum(44,89) = -1
  StoichNum(44,90) = -1
  StoichNum(44,91) = -1
  StoichNum(44,92) = -1
  StoichNum(44,93) = -1
  StoichNum(44,94) = -1
  StoichNum(44,95) = -2
  StoichNum(44,106) = 0.37
  StoichNum(45,3) = 1
  StoichNum(45,4) = 1
  StoichNum(45,6) = -1
  StoichNum(45,7) = -1
  StoichNum(45,8) = -2
  StoichNum(45,10) = 1
  StoichNum(45,20) = -1
  StoichNum(45,23) = -1
  StoichNum(45,24) = -1
  StoichNum(45,27) = 1
  StoichNum(45,31) = -1
  StoichNum(45,32) = -1
  StoichNum(45,33) = 1
  StoichNum(45,44) = 1
  StoichNum(45,48) = 0.85
  StoichNum(45,49) = -1
  StoichNum(45,50) = -1
  StoichNum(45,57) = 1
  StoichNum(45,58) = 1
  StoichNum(45,60) = 1
  StoichNum(45,65) = 1
  StoichNum(45,72) = -1
  StoichNum(45,73) = 1
  StoichNum(45,74) = -0.8
  StoichNum(45,75) = 1
  StoichNum(45,76) = 1
  StoichNum(45,77) = 1
  StoichNum(45,81) = 1
  StoichNum(45,82) = 1
  StoichNum(45,83) = 1
  StoichNum(45,93) = -1
  StoichNum(45,105) = 1
  StoichNum(45,106) = 0.16
  StoichNum(45,125) = 0.667
  StoichNum(45,128) = 1
  StoichNum(45,132) = 1
  StoichNum(45,134) = 1
  StoichNum(45,135) = 0.333
  StoichNum(46,48) = 0.85
  StoichNum(46,50) = 1
  StoichNum(46,55) = 0.5
  StoichNum(46,56) = 0.4
  StoichNum(46,57) = -1
  StoichNum(46,58) = -1
  StoichNum(46,63) = 1
  StoichNum(46,64) = 1
  StoichNum(46,65) = 1
  StoichNum(46,67) = 1
  StoichNum(46,69) = 1
  StoichNum(46,71) = 1
  StoichNum(46,72) = -1
  StoichNum(46,73) = 1
  StoichNum(46,86) = 1
  StoichNum(46,87) = 1
  StoichNum(46,88) = 1
  StoichNum(46,90) = -1
  StoichNum(46,94) = 1
  StoichNum(46,95) = 2
  StoichNum(46,100) = 0.956
  StoichNum(46,101) = 0.83
  StoichNum(46,103) = 0.25
  StoichNum(46,105) = -1
  StoichNum(46,127) = -1
  StoichNum(46,128) = -1
  StoichNum(46,133) = 1
  StoichNum(47,2) = 1
  StoichNum(47,4) = -1
  StoichNum(47,6) = -1
  StoichNum(47,14) = -1
  StoichNum(47,15) = -1
  StoichNum(47,30) = -1
  StoichNum(47,37) = -1
  StoichNum(47,70) = -1
  StoichNum(47,94) = -1
  StoichNum(47,100) = -1
  StoichNum(47,102) = -1
  StoichNum(47,116) = -1
  StoichNum(47,117) = -1
      
END SUBROUTINE CalcStoichNum

! End of CalcStoichNum function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE messy_mecca_kpp_Function

